package LineHash;
require Exporter;
@EXPORT_OK   = qw( %lineHash %preProcData );
%EXPORT_TAGS = ( all => [ @EXPORT_OK ] );
@ISA         = qw(Exporter);

BEGIN {

  %preProcData = (

    'L1_Canis1_3end' => { 'relToReference' => 5488 },
    'L1_RS30_3end'   => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'Lx2B_3end'    => { 'relToReference' => 5586 },
    'L1_Mdo1_3end' => { 'relToReference' => 5488 },
    'L1_Mdo5_3end' => { 'relToReference' => 5488 },
    'L2c_3end'     => { 'relToReference' => 2909 },
    'L1Md_A_5end'  => { '3EndLength'     => 5380 },
    'L1MD_orf2'    => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1PA10_5end' => {
                       '3EndLength'     => 3909,
                       'relToReference' => -185
    },
    'L1MC4_5end' => {
                      '3EndLength'     => 3660,
                      'relToReference' => -68,
                      'rangeNames'     => [
                                        {
                                          'name'   => 'L1M5',
                                          'minBeg' => 2110
                                        }
                      ]
    },
    'L1_RS10_3end' => {
                        'Reltoreference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'CR1-C2_3end'  => { 'relToReference' => 3322 },
    'L1-1_ME_3end' => { 'relToReference' => 5488 },
    'L1M3a_5end'   => {
                      '3EndLength'     => 4780,
                      'relToReference' => 112
    },
    'L1PA12_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1_Opos2_3end' => { 'relToReference' => 5488 },
    'L1_Mur3_orf2'  => { 'relToReference' => 1202 },
    'L1MB4_5end'    => {
                      '3EndLength'     => 4812,
                      'relToReference' => -601
    },
    'MusHAL1_5end' => {
                        '3EndLength'     => 2570,
                        'relToReference' => 561
    },
    'L1PA8A_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1Md_Gf_5end' => {
                        '3EndLength'     => 5380,
                        'relToReference' => -3
    },
    'CR1-Y3_3end' => { 'relToReference' => 3301 },
    'L2'          => { '3EndLength'     => 337 },
    'L1MA4A_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M1'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1_Mus2_3end' => { 'relToReference' => 5586 },
    'L1MC3_3end'   => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MC'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Canis1_5end' => {
                          '3EndLength'     => 3957,
                          'relToReference' => 222
    },
    'Lx3_Mus_3end' => { 'relToReference' => 5586 },
    'L1_Rn_5end'   => { 'relToReference' => 363 },
    'L1M2a_5end'   => {
                      '3EndLength'     => 4935,
                      'relToReference' => -1021
    },
    'Lx3B_3end'     => { 'relToReference' => 5586 },
    'L1_Carn5_5end' => {
                         '3EndLength'     => 3957,
                         'relToReference' => -355
    },
    'L1PB3_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1M2c_5end' => {
                      '3EndLength'     => 4455,
                      'relToReference' => -642
    },
    'L1_Rat1_3end' => { 'relToReference' => 5586 },
    'L1_Mur2_5end' => {
                        '3EndLength'     => 5742,
                        'relToReference' => 374
    },
    'L1PBa_5end' => {
                      '3EndLength'     => 3892,
                      'relToReference' => -716
    },
    'L1MC5_3end' => {
                      'relToReference' => 6610,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MC'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Mus3_3end'   => { 'relToReference' => 5586 },
    'Lx3A_3end'      => { 'relToReference' => 5586 },
    'L1_Canis2_5end' => {
                          '3EndLength'     => 3957,
                          'relToReference' => -558
    },
    'L1_RS38_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1PA13_5end' => {
                       '3EndLength'     => 3904,
                       'relToReference' => -620
    },
    'L1MB4_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M3'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1P4a_5end' => {
                      '3EndLength'     => 3907,
                      'relToReference' => -337
    },
    'Lx4A_3end'  => { 'relToReference' => 5586 },
    'L1MA9_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1MB7_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M4'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Opos3_3end' => { 'relToReference' => 5488 },
    'L1Pt_3end'     => {
                     'relToReference' => 5253,
                     'rangeNames'     => [
                                       {
                                         'maxEnd' => '5429',
                                         'name'   => 'L1P'
                                       }
                     ]
    },
    'L1P4_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1_Rn2_3end' => { 'relToReference' => 5586 },
    'L1_RS1_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1PA7_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P3'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1ME3_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1MB2_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M3'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1P3b_5end' => {
                      '3EndLength'     => 4734,
                      'relToReference' => -315
    },
    'L1MD2_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MD'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Opos_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1PA2_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P1'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1Md_T_3end' => { 'relToReference' => 5586 },
    'L1MEd_5end'  => {
                      '3EndLength'     => 4862,
                      'relToReference' => 17
    },
    'L1_Fc_orf2' => {
                      '3EndLength'     => 813,
                      'relToReference' => 2344
    },
    'HAL1_Opos_3end' => { 'relToReference' => 5488 },
    'L1_Carn1_5end'  => {
                         '3EndLength'     => 3957,
                         'relToReference' => -188
    },
    'L1-1_ME_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1_Opos3_orf2' => {
                         '3EndLength'     => 813,
                         'relToReference' => 2344
    },
    'L1_Mdo3a_3end' => { 'relToReference' => 5488 },
    'L1_Cf_5end'    => {
                      '3EndLength'     => 3957,
                      'relToReference' => 63,
                      'rangeNames'     => [
                                        {
                                          'name'   => 'L1_Canis0',
                                          'minBeg' => 1
                                        }
                      ]
    },
    'L1_Canid_orf2' => {
                         '3EndLength'     => 813,
                         'relToReference' => 2344,
                         'rangeNames'     => [
                                           {
                                             'name'   => 'L1_Canis4_',
                                             'minBeg' => 1
                                           }
                         ]
    },
    'L1MD1_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MD'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_RS31_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1MEg_5end' => {
                      '3EndLength'     => 3983,
                      'relToReference' => 158
    },
    'L1_Carn7_5end' => {
                         '3EndLength'     => 3957,
                         'relToReference' => -562
    },
    'L1_Cric'      => { 'relToReference' => 6425 },
    'CR1-X2_3end'  => { 'relToReference' => 3036 },
    'L1Md_F3_3end' => { 'relToReference' => 5586 },
    'L1_RS21_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1-2_ME_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1MA3_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M1'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'CR1-F0_3end'  => { 'relToReference' => 3036 },
    'Lx5_3end'     => { 'relToReference' => 5586 },
    'L1_Mur1_5end' => {
                        '3EndLength'     => 5640,
                        'relToReference' => 2
    },
    'L1_Rn_orf2'   => { 'relToReference' => 1202 },
    'L1PREC2_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1PA10_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1_Mur3_5end' => {
                        '3EndLength'     => 6384,
                        'relToReference' => 16
    },
    'L1_Carni_orf2' => {
                         '3EndLength'     => 813,
                         'relToReference' => 3922
    },
    'L1_RS35_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1MB5_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M4'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Felid_3end' => { 'relToReference' => 5488 },
    'L1-1_MD_3end'  => { 'relToReference' => 5488 },
    'L1_RS36_3end'  => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1VL1_5end' => {
                      '3EndLength'     => 5294,
                      'relToReference' => 216
    },
    'L1_Rod_5end' => {
                       '3EndLength'     => 6252,
                       'relToReference' => 436
    },
    'L1M2_5end' => {
                     '3EndLength'     => 3945,
                     'relToReference' => -702
    },
    'L1_Carn7_3end' => { 'relToReference' => 5488 },
    'L1M4c_5end'    => {
                      '3EndLength'     => 3884,
                      'relToReference' => -236
    },
    'L1PA15_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1_Mdo1_5end' => {
                        '3EndLength'     => 3939,
                        'relToReference' => 11
    },
    'CR1-X1_3end'   => { 'relToReference' => 3036 },
    'L1_Carn2_5end' => {
                         '3EndLength'     => 3957,
                         'relToReference' => 226
    },
    'L1Md_F_5end' => {
                       '3EndLength'     => 5380,
                       'relToReference' => 97
    },
    'L1M4_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1ME1_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1P4d_5end' => {
                      '3EndLength'     => 4900,
                      'relToReference' => -769
    },
    'L3b_3end'   => { 'relToReference' => 4026 },
    'L1MDb_5end' => {
                      '3EndLength'     => 4987,
                      'relToReference' => -260
    },
    'L1_Mdo4_3end'  => { 'relToReference' => 5488 },
    'L1_Mars1_orf2' => {
                         '3EndLength'     => 813,
                         'relToReference' => 2344
    },
    'Lx2_3end'   => { 'relToReference' => 5586 },
    'L1MC2_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MC'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1M3b_5end' => {
                      '3EndLength'     => 4516,
                      'relToReference' => -204
    },
    'L1M3d_5end' => {
                      '3EndLength'     => 4516,
                      'relToReference' => 176
    },
    'L1MCa_5end' => {
                      '3EndLength'     => 4074,
                      'relToReference' => -175
    },
    'L1_Mdo2_3end' => { 'relToReference' => 5488 },
    'L1MA5A_3end'  => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M2'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1MC4_3endX' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1MC'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1_RS37_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1PBb_5end' => {
                      '3EndLength'     => 5146,
                      'relToReference' => -57
    },
    'L1M3f_5end' => {
                      '3EndLength'     => 4065,
                      'relToReference' => -182
    },
    'L1M3c_5end' => {
                      '3EndLength'     => 4516,
                      'relToReference' => -64
    },
    'L1M3_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1Md_F2_3end' => { 'relToReference' => 5586 },
    'L1MEa_5end'   => {
                      '3EndLength'     => 4981,
                      'relToReference' => 66
    },
    'L1M2a1_5end' => {
                       '3EndLength'     => 5274,
                       'relToReference' => -969
    },
    'L1MA6_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1PREC2_5end' => {
                        '3EndLength'     => 3901,
                        'relToReference' => -1995
    },
    'L1P3_5end' => {
                     '3EndLength'     => 4734,
                     'relToReference' => -315
    },
    'L1HS_5end' => {
                     '3EndLength'     => 3896,
                     'relToReference' => 123
    },
    'L2a_3end'    => { 'relToReference' => 2909 },
    'L1MEg2_5end' => {
                       '3EndLength'     => 5452,
                       'relToReference' => -1308
    },
    'L1PA12_5end' => {
                       '3EndLength'     => 3909,
                       'relToReference' => -1435
    },
    'L1MDa_5end' => {
                      '3EndLength'     => 3983,
                      'relToReference' => -391
    },
    'L1MEe_5end' => {
                      '3EndLength'     => 3690,
                      'relToReference' => 1312
    },
    'L1ME2_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_RS16_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'RNHAL1_5end' => {
                       '3EndLength'     => 2313,
                       'relToReference' => -167
    },
    'Lx2A1_3end'    => { 'relToReference' => 5586 },
    'L1_Opos0_3end' => { 'relToReference' => 5488 },
    'Lx_3end'       => { 'relToReference' => 5586 },
    'L1_Canid_3end' => {
                         'relToReference' => 5488,
                         'rangeNames'     => [
                                           {
                                             'name'   => 'L1_Canis4_',
                                             'minBeg' => 1
                                           }
                         ]
    },
    'L1P1_5end'    => { '3EndLength'     => 3896 },
    'CR1-Y4_3end'  => { 'relToReference' => 3301 },
    'L1_Mur2_orf2' => { 'relToReference' => 1202 },
    'L1PA17_3end'  => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1-4A_ME_3end' => { 'relToReference' => 5488 },
    'L1M1_orf2'     => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1_Carni_3end' => { 'relToReference' => 5488 },
    'L1_Rat4_3end'  => { 'relToReference' => 5586 },
    'L1ME2z_3end'   => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1M3e_5end' => {
                      '3EndLength'     => 4917,
                      'relToReference' => -960
    },
    'L1_Mdo4_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1VL2_5end' => {
                      '3EndLength'     => 5290,
                      'relToReference' => 299
    },
    'L1PA8_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P3'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1-4_ME_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1PA6_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1ME3B_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L2b_3end'     => { 'relToReference' => 2909 },
    'Lx9_3end'     => { 'relToReference' => 5586 },
    'L1PREC2_orf2' => {
                        '3EndLength'     => 743,
                        'relToReference' => 2109
    },
    'L1P3_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1M1_5end' => {
                     '3EndLength'     => 3890,
                     'relToReference' => -1419
    },
    'L1MA8_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'CR1-D2_3end'   => { 'relToReference' => 3457 },
    'L1_Carn5_3end' => { 'relToReference' => 5488 },
    'L1PA5_3end'    => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1_Mm_orf2' => { 'relToReference' => 1202 },
    'L1M2b_5end' => {
                      '3EndLength'     => 5179,
                      'relToReference' => -1062
    },
    'L1_Carn2_orf2' => {
                         '3EndLength'     => 813,
                         'relToReference' => 2344
    },
    'L1PA16_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1ME3C_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1ME3Cz_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd'           => '5824',
                                            'maxArianEndScore' => '6164',
                                            'name'             => 'L1M5'
                                          },
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1M'
                                          }
                        ]
    },
    'L1ME3D_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1ME3E_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1ME3F_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1ME3G_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1ME3A_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'HAL1N1_MD_3end' => { 'relToReference' => 5488 },
    'L1ME4a_3end'    => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M5'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1_Rod_orf2' => { 'relToReference' => 1202 },
    'L1PBa1_5end' => {
                       '3EndLength'     => 5020,
                       'relToReference' => -466
    },
    'L1P4e_5end' => {
                      '3EndLength'     => 4900,
                      'relToReference' => -125
    },
    'L1_Canis1_orf2' => {
                          '3EndLength'     => 813,
                          'relToReference' => 2344
    },
    'L1_Fc_5end' => {
                      '3EndLength'     => 3957,
                      'relToReference' => 467
    },
    'L1P4c_5end' => {
                      '3EndLength'     => 5051,
                      'relToReference' => -468
    },
    'L1_Canid_5end' => {
                         'rangeNames' => [
                                           {
                                             'name'   => 'L1_Canis4_',
                                             'minBeg' => 1
                                           }
                         ]
    },
    'Lx7_3end'      => { 'relToReference' => 5586 },
    'L1_Mdo3b_3end' => { 'relToReference' => 5488 },
    'L1_Carn7_orf2' => {
                         '3EndLength'     => 813,
                         'relToReference' => 2344
    },
    'L1PA14_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1_Mus1_3end' => { 'relToReference' => 5586 },
    'L1-1_ME_5end' => {
                        '3EndLength'     => 3959,
                        'relToReference' => 377
    },
    'L1_Canis2_orf2' => {
                          '3EndLength'     => 813,
                          'relToReference' => 2344
    },
    'L1MA2_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M1'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1-4_ME_3end' => { 'relToReference' => 5488 },
    'L1VL4a_5end'  => {
                       '3EndLength'     => 5309,
                       'relToReference' => 356
    },
    'L1_Mars1b_3end' => { 'relToReference' => 5488 },
    'L1PA4_3end'     => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1M4_5end' => {
                     '3EndLength'     => 4831,
                     'relToReference' => -498
    },
    'L1M4b_5end' => {
                      '3EndLength'     => 3630,
                      'relToReference' => -860
    },
    'L1MA10_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => 6189,
                                           'relLeftUnaligned' => -145,
                                           'name'             => 'L1MB1_3end'
                                         },
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1M3'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L3b'          => { 'relToReference' => 4026 },
    'L1-2_ME_5end' => {
                        '3EndLength'     => 3951,
                        'relToReference' => 135
    },
    'L1MA7_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'RNHAL1' => {
                  'relToReference' => 1202,
                  'minStrongEnd'   => 2431
    },
    'L1_Mdo6_3end' => { 'relToReference' => 5488 },
    'L1_RS1_orf2'  => {
                       '3EndLength'     => 743,
                       'relToReference' => 2109
    },
    'L1-2_ME_3end' => { 'relToReference' => 5488 },
    'CR1-Y2_3end'  => { 'relToReference' => 3301 },
    'L1_Mdo1_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1_Mdo5_5end' => {
                        '3EndLength'     => 3939,
                        'relToReference' => -186
    },
    'L1_RS23_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'L1MEb_5end' => {
                      '3EndLength'     => 4981,
                      'relToReference' => 66
    },
    'Lx2A_3end'  => { 'relToReference' => 5586 },
    'L1_Cf_orf2' => {
                      '3EndLength'     => 813,
                      'relToReference' => 2344,
                      'rangeNames'     => [
                                        {
                                          'name'   => 'L1_Canis0',
                                          'minBeg' => 1
                                        }
                      ]
    },
    'L1_Rn_3end'  => { 'relToReference' => 5586 },
    'L1M3de_5end' => {
                       '3EndLength'     => 4516,
                       'relToReference' => -586
    },
    'L1PB1_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1MA1_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M1'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1VL4_5end' => {
                      '3EndLength'     => 5313,
                      'relToReference' => 355
    },
    'L1MD2_5end' => {
                      '3EndLength'     => 5478,
                      'relToReference' => -398
    },
    'L1_Canid2_5end' => {
                          '3EndLength'     => 3957,
                          'relToReference' => -326
    },
    'L1-1_MD_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1P1_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1Pt_5end' => {
                     '3EndLength'     => 3896,
                     'relToReference' => 123
    },
    'L1_Opos1_3end' => { 'relToReference' => 5488 },
    'L1M7_5end'     => {
                     '3EndLength'     => 3981,
                     'relToReference' => 25
    },
    'L1_Fc_3end' => { 'relToReference' => 5488 },
    'L1MB8_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M4'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Carn2_3end' => { 'relToReference' => 5488 },
    'L1M5_orf2'     => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'Lx4B_3end'   => { 'relToReference' => 5586 },
    'CR1-H2_3end' => { 'relToReference' => 3573 },
    'L1MB1_3end'  => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M3'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Mdo2_5end' => {
                        '3EndLength'     => 3939,
                        'relToReference' => 43
    },
    'L1MC4_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MC'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1HS_3end' => {
                     'relToReference' => 5253,
                     'rangeNames'     => [
                                       {
                                         'maxEnd'           => '5824',
                                         'maxArianEndScore' => '6164',
                                         'name'             => 'L1P1'
                                       },
                                       {
                                         'maxEnd' => '5429',
                                         'name'   => 'L1P'
                                       }
                     ]
    },
    'L1_Rat3_3end' => { 'relToReference' => 5586 },
    'L1_RS25_3end' => {
                        'relToReference' => 5253,
                        'rangeNames'     => [
                                          {
                                            'maxEnd' => '5429',
                                            'name'   => 'L1P'
                                          }
                        ]
    },
    'MusHAL1' => {
                   'relToReference' => 1202,
                   'minStrongEnd'   => 3641
    },
    'L1_Mur1_orf2' => { 'relToReference' => 1202 },
    'L1_Cf_3end'   => {
                      'relToReference' => 5488,
                      'rangeNames'     => [
                                        {
                                          'name'   => 'L1_Canis0',
                                          'minBeg' => 1
                                        }
                      ]
    },
    'L1MEg1_5end' => {
                       '3EndLength'     => 5452,
                       'relToReference' => -1091
    },
    'L1_RS1_5end' => {
                       '3EndLength'     => 3887,
                       'relToReference' => 10
    },
    'L1MEc_5end' => {
                      '3EndLength'     => 3873,
                      'relToReference' => -173
    },
    'CR1-B2_3end'  => { 'relToReference' => 3339 },
    'L1_Mdo5_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1MA4_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M1'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1PB_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1ME5_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1MD3_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MD'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1Md_A_3end' => { 'relToReference' => 5586 },
    'L1MB3_3end'  => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M3'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_Mus4_3end' => { 'relToReference' => 5586 },
    'CR1-F2_3end'  => { 'relToReference' => 3036 },
    'L1PB2_3end'   => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P5'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'L1_Carn3_3end'   => { 'relToReference' => 5488 },
    'HAL1_Opos1_3end' => { 'relToReference' => 5488 },
    'L1M6_5end'       => {
                     '3EndLength'     => 3981,
                     'relToReference' => -254
    },
    'L1MEf_5end' => {
                      '3EndLength'     => 3983,
                      'relToReference' => 42
    },
    'L1PA13_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1PA3_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P1'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1P'
                                        }
                      ]
    },
    'Lx3C_3end'      => { 'relToReference' => 5586 },
    'L1PA15-16_5end' => {
                          '3EndLength'     => 3891,
                          'relToReference' => -703
    },
    'L1MC1_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1MC'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'L1_RS2_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1MA5_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1M2'
                                        },
                                        {
                                          'maxEnd' => '5429',
                                          'name'   => 'L1M'
                                        }
                      ]
    },
    'Lx6_3end'  => { 'relToReference' => 5586 },
    'L1M2_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1MCc_5end' => {
                      '3EndLength'     => 4887,
                      'relToReference' => -795
    },
    'L1_Mars1_5end' => {
                         '3EndLength'     => 3958,
                         'relToReference' => -815
    },
    'L1-1_MD_5end' => {
                        '3EndLength'     => 3934,
                        'relToReference' => 138
    },
    'L1MCb_5end' => {
                      '3EndLength'     => 4848,
                      'relToReference' => -418
    },
    'L1MC_orf2' => {
                     '3EndLength'     => 743,
                     'relToReference' => 2109
    },
    'L1PA14_5end' => {
                       '3EndLength'     => 3902,
                       'relToReference' => -527
    },
    'L1PA17_5end' => {
                       '3EndLength'     => 5139,
                       'relToReference' => -427
    },
    'L1_Mdo4_5end' => {
                        '3EndLength'     => 3939,
                        'relToReference' => -254
    },
    'Lx8_3end'     => { 'relToReference' => 5586 },
    'L1_Rat2_3end' => { 'relToReference' => 5586 },
    'L1_Mdo2_orf2' => {
                        '3EndLength'     => 813,
                        'relToReference' => 2344
    },
    'L1PA11_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1P4'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1P'
                                         }
                       ]
    },
    'L1PB4_3end' => {
                      'relToReference' => 5253,
                      'rangeNames'     => [
                                        {
                                          'maxEnd'           => '5824',
                                          'maxArianEndScore' => '6164',
                                          'name'             => 'L1P5'
                                        }
                      ]
    },
    'L1_Mars1a_3end' => { 'relToReference' => 5488 },
    'L1_Carn3_5end'  => {
                         '3EndLength'     => 3957,
                         'relToReference' => -215
    },
    'L1MC4a_3end' => {
                       'relToReference' => 5253,
                       'rangeNames'     => [
                                         {
                                           'maxEnd'           => '5824',
                                           'maxArianEndScore' => '6164',
                                           'name'             => 'L1MC'
                                         },
                                         {
                                           'maxEnd' => '5429',
                                           'name'   => 'L1M'
                                         }
                       ]
    },
    'L1P4b_5end' => {
                      '3EndLength'     => 5551,
                      'relToReference' => -1168
    },
    'L1_Opos4b_3end' => { 'relToReference' => 5488 }

      ),

      %lineHash = (

    'L1M2' => {
                'L1M2a1_5end' => { 'overThresh' => 0 },
                'L1MA6_3end'  => { 'overThresh' => 0 },
                'L1M1_orf2'   => { 'overThresh' => 0 },
                'L1M2b_5end'  => { 'overThresh' => 0 },
                'L1M3a_5end'  => { 'overThresh' => 0 },
                'L1M3e_5end'  => { 'overThresh' => 0 },
                'L1MA4A_3end' => { 'overThresh' => 0 },
                'L1M2_5end'   => { 'overThresh' => 0 },
                'L1M3b_5end'  => { 'overThresh' => 0 },
                'L1M3d_5end'  => { 'overThresh' => 0 },
                'L1MA4_3end'  => { 'overThresh' => 0 },
                'L1MA5A_3end' => { 'overThresh' => 0 },
                'L1MA8_3end'  => { 'overThresh' => 0 },
                'L1M1_5end'   => { 'overThresh' => 0 },
                'L1M2a_5end'  => { 'overThresh' => 0 },
                'L1M1'        => { 'overThresh' => 0 },
                'L1M3c_5end'  => { 'overThresh' => 0 },
                'L1M3_orf2'   => { 'overThresh' => 0 },
                'L1M3f_5end'  => { 'overThresh' => 0 },
                'L1MA5_3end'  => { 'overThresh' => 0 },
                'L1M3de_5end' => { 'overThresh' => 0 },
                'L1M3'        => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 },
                'L1M2_orf2'   => { 'overThresh' => 0 },
                'L1MA9_3end'  => { 'overThresh' => 0 },
                'L1M2c_5end'  => { 'overThresh' => 0 },
                'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'L1_Canis1_3end' => {
                          'L1_Canis2_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis2_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1_Mdo1_3end' => {
                        'L1_Mdo1_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_5end' => { 'overThresh' => 0 },
                        'L1_Mdo2_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo1_5end' => { 'overThresh' => 0 }
    },
    'Lx2B_3end' => {
                     'L1_Rat1_3end' => { 'overThresh' => 33 },
                     'L1_Rat4_3end' => { 'overThresh' => 33 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mus3_3end' => { 'overThresh' => 33 },
                     'L1_Mus1_3end' => { 'overThresh' => 33 },
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Rat2_3end' => { 'overThresh' => 33 },
                     'L1_Rn_orf2'   => { 'overThresh' => 0 },
                     'L1_Mus2_3end' => { 'overThresh' => 33 },
                     'L1_Mm_orf2'   => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Rat3_3end' => { 'overThresh' => 33 },
                     'L1_Mus4_3end' => { 'overThresh' => 33 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1_Mdo5_3end' => {
                        'L1_Mdo4_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo5_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo4_5end' => { 'overThresh' => 0 },
                        'L1_Mdo5_5end' => { 'overThresh' => 0 }
    },
    'L1Md_A_5end' => {
                       'L1Md_T_3end'  => { 'overThresh' => 0 },
                       'L1_Mus1_3end' => { 'overThresh' => 33 },
                       'L1_Mus3_3end' => { 'overThresh' => 33 },
                       'L1Md_F_5end'  => { 'overThresh' => 0 },
                       'L1Md_Gf_5end' => { 'overThresh' => 0 },
                       'L1_Mm_orf2'   => { 'overThresh' => 0 },
                       'L1_Mus2_3end' => { 'overThresh' => 33 },
                       'L1_Mus4_3end' => { 'overThresh' => 33 },
                       'L1Md_A_3end'  => { 'overThresh' => 0 },
                       'L1Md_F3_3end' => { 'overThresh' => 0 },
                       'L1Md_F2_3end' => { 'overThresh' => 0 }
    },
    'L1MD_orf2' => {
                     'L1MD'        => { 'overThresh' => 0 },
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1ME2z_3end' => { 'overThresh' => 33 },
                     'L1MC5_3end'  => { 'overThresh' => 33 },
                     'L1MC2_3end'  => { 'overThresh' => 33 },
                     'L1MD1_3end'  => { 'overThresh' => 0 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1ME3B_3end' => { 'overThresh' => 33 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1MC1_3end'  => { 'overThresh' => 33 },
                     'L1MC4_3end'  => { 'overThresh' => 33 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 },
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1ME3_3end'  => { 'overThresh' => 33 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1ME3A_3end' => { 'overThresh' => 33 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1ME2_3end'  => { 'overThresh' => 33 },
                     'L1MD2_3end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1MC3_3end'  => { 'overThresh' => 33 },
                     'L1ME4a_3end' => { 'overThresh' => 33 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1MEb_5end'  => { 'overThresh' => 0 },
                     'L1ME5_3end'  => { 'overThresh' => 33 },
                     'L1MC4a_3end' => { 'overThresh' => 33 },
                     'L1ME1_3end'  => { 'overThresh' => 33 },
                     'L1MD3_3end'  => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1PA10_5end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1Pt_5end'      => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1P1_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_orf2'   => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PBb_5end'     => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_5end'   => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB_orf2'      => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P1_5end'      => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1MC4_5end' => {
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1M3a_5end' => {
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'L1PA12_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1_Opos2_3end' => {
                         'L1_Opos3_orf2'   => { 'overThresh' => 0 },
                         'HAL1_Opos1_5end' => { 'overThresh' => 0 }
    },
    'L1_Mur3_orf2' => {
                        'Lx5_3end'     => { 'overThresh' => 0 },
                        'Lx7_3end'     => { 'overThresh' => 0 },
                        'Lx8_3end'     => { 'overThresh' => 0 },
                        'Lx6_3end'     => { 'overThresh' => 0 },
                        'L1_Mur2_orf2' => { 'overThresh' => 0 },
                        'L1_Mur2_5end' => { 'overThresh' => 0 },
                        'L1_Mur3_5end' => { 'overThresh' => 0 }
    },
    'L1MB4_5end' => {
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 0 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'MusHAL1_5end' => { 'MusHAL1' => { 'overThresh' => 0 } },
    'L1PA8A_3end'  => {
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 33 },
                       'L1PA14_3end'    => { 'overThresh' => 33 },
                       'L1PA16_3end'    => { 'overThresh' => 33 },
                       'L1P2'           => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA13_3end'    => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PA6_3end'     => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 33 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 0 },
                       'L1PA13_5end'    => { 'overThresh' => 33 },
                       'L1PA15-16_5end' => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1Md_Gf_5end' => {
                        'L1Md_T_3end'  => { 'overThresh' => 0 },
                        'L1Md_A_5end'  => { 'overThresh' => 0 },
                        'L1_Mus1_3end' => { 'overThresh' => 33 },
                        'L1_Mus3_3end' => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 0 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1_Mus2_3end' => { 'overThresh' => 33 },
                        'L1_Mus4_3end' => { 'overThresh' => 33 },
                        'L1Md_A_3end'  => { 'overThresh' => 0 },
                        'L1Md_F3_3end' => { 'overThresh' => 0 },
                        'L1Md_F2_3end' => { 'overThresh' => 0 }
    },
    'L1MA4A_3end' => {
                       'L1MA6_3end'  => { 'overThresh' => 0 },
                       'L1M2a1_5end' => { 'overThresh' => 0 },
                       'L1M1_orf2'   => { 'overThresh' => 0 },
                       'L1M2'        => { 'overThresh' => 0 },
                       'L1M2b_5end'  => { 'overThresh' => 0 },
                       'L1MB2_3end'  => { 'overThresh' => 33 },
                       'L1MB4_5end'  => { 'overThresh' => 33 },
                       'L1M2_5end'   => { 'overThresh' => 0 },
                       'L1MA2_3end'  => { 'overThresh' => 0 },
                       'L1MA4_3end'  => { 'overThresh' => 0 },
                       'L1MB8_3end'  => { 'overThresh' => 33 },
                       'L1MA3_3end'  => { 'overThresh' => 0 },
                       'L1MA5A_3end' => { 'overThresh' => 0 },
                       'L1M2a_5end'  => { 'overThresh' => 0 },
                       'L1M1_5end'   => { 'overThresh' => 0 },
                       'L1MA8_3end'  => { 'overThresh' => 33 },
                       'L1MB4_3end'  => { 'overThresh' => 33 },
                       'L1M1'        => { 'overThresh' => 0 },
                       'L1MB1_3end'  => { 'overThresh' => 33 },
                       'L1MA5_3end'  => { 'overThresh' => 0 },
                       'L1MA10_3end' => { 'overThresh' => 33 },
                       'L1PB3_3end'  => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 33 },
                       'L1M2_orf2'   => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MB3_3end'  => { 'overThresh' => 33 },
                       'L1M2c_5end'  => { 'overThresh' => 0 },
                       'L1MA7_3end'  => { 'overThresh' => 33 },
                       'L1MA1_3end'  => { 'overThresh' => 0 },
                       'L1MB5_3end'  => { 'overThresh' => 33 },
                       'L1MB7_3end'  => { 'overThresh' => 33 }
    },
    'L2a_3end' => {
                    'L2b_3end' => { 'overThresh' => 0 },
                    'L2c_3end' => { 'overThresh' => 0 },
                    'L2'       => { 'overThresh' => 0 }
    },
    'L2b_3end' => {
                    'L2a_3end' => { 'overThresh' => 0 },
                    'L2c_3end' => { 'overThresh' => 0 },
                    'L2'       => { 'overThresh' => 0 }
    },
    'L2c_3end' => {
                    'L2a_3end' => { 'overThresh' => 0 },
                    'L2b_3end' => { 'overThresh' => 0 },
                    'L2'       => { 'overThresh' => 0 }
    },
    'L2' => {
              'L2a_3end' => { 'overThresh' => 0 },
              'L2b_3end' => { 'overThresh' => 0 },
              'L2c_3end' => { 'overThresh' => 0 }
    },
    'L1_Mus2_3end' => {
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1Md_Gf_5end' => { 'overThresh' => 33 },
                        'L1_Mus3_3end' => { 'overThresh' => 0 },
                        'L1_Mus1_3end' => { 'overThresh' => 0 },
                        'L1Md_F3_3end' => { 'overThresh' => 33 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'L1Md_T_3end'  => { 'overThresh' => 33 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'L1Md_A_5end'  => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 33 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1_Mus4_3end' => { 'overThresh' => 0 },
                        'L1Md_A_3end'  => { 'overThresh' => 33 },
                        'L1Md_F2_3end' => { 'overThresh' => 33 }
    },
    'L1MC3_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1_Canis1_5end' => {
                          'L1_Canis2_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_3end' => { 'overThresh' => 0 },
                          'L1_Canis2_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_3end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'Lx3_Mus_3end' => {
                        'L1_Mur1_5end' => { 'overThresh' => 0 },
                        'L1_Mur2_orf2' => { 'overThresh' => 0 },
                        'L1_Mur2_5end' => { 'overThresh' => 0 },
                        'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1_Rn_5end' => {
                      'L1_Rat1_3end' => { 'overThresh' => 33 },
                      'L1_Rn2_3end'  => { 'overThresh' => 0 },
                      'L1_Rn_orf2'   => { 'overThresh' => 0 },
                      'L1_Rat2_3end' => { 'overThresh' => 33 },
                      'L1_Rat4_3end' => { 'overThresh' => 33 },
                      'L1_Rat3_3end' => { 'overThresh' => 33 },
                      'L1_Rn_3end'   => { 'overThresh' => 0 }
    },
    'L1M2a_5end' => {
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'Lx3B_3end' => {
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1_Carn5_5end' => { 'L1_Carn5_3end' => { 'overThresh' => 0 } },
    'L1PB3_3end'    => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1MA4A_3end'    => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1MA4_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PB4_3end'     => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1PB1_3end'     => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1M2c_5end' => {
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'L1_Rat1_3end' => {
                        'L1_Rn_5end'   => { 'overThresh' => 33 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'L1_Rn2_3end'  => { 'overThresh' => 33 },
                        'L1_Rat4_3end' => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1_Rn_3end'   => { 'overThresh' => 33 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Rn_orf2'   => { 'overThresh' => 33 },
                        'L1_Rat2_3end' => { 'overThresh' => 0 },
                        'L1_Rat3_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 }
    },
    'L1_Mur2_5end' => {
                        'Lx2_3end'     => { 'overThresh' => 0 },
                        'L1_Mur3_orf2' => { 'overThresh' => 0 },
                        'Lx2B_3end'    => { 'overThresh' => 0 },
                        'Lx3A_3end'    => { 'overThresh' => 0 },
                        'Lx3_Mus_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 0 },
                        'Lx3C_3end'    => { 'overThresh' => 0 },
                        'Lx3B_3end'    => { 'overThresh' => 0 },
                        'Lx4B_3end'    => { 'overThresh' => 0 },
                        'Lx5_3end'     => { 'overThresh' => 0 },
                        'Lx6_3end'     => { 'overThresh' => 0 },
                        'L1_Mur1_5end' => { 'overThresh' => 0 },
                        'L1_Mur2_orf2' => { 'overThresh' => 0 },
                        'Lx4A_3end'    => { 'overThresh' => 0 },
                        'L1_Mur3_5end' => { 'overThresh' => 0 },
                        'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'TX1_FR2'    => { 'TX1' => { 'overThresh' => 0 } },
    'L1PBa_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PB4_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1PB1_3end'     => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'HAL1b'      => { 'HAL1' => { 'overThresh' => 0 } },
    'L1MC5_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1_Mus3_3end' => {
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1Md_Gf_5end' => { 'overThresh' => 33 },
                        'L1_Mus1_3end' => { 'overThresh' => 0 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Mus2_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 },
                        'L1Md_F3_3end' => { 'overThresh' => 33 },
                        'L1Md_T_3end'  => { 'overThresh' => 33 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'L1Md_A_5end'  => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 33 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1Md_A_3end'  => { 'overThresh' => 33 },
                        'L1_Mus4_3end' => { 'overThresh' => 0 },
                        'L1Md_F2_3end' => { 'overThresh' => 33 }
    },
    'Lx3A_3end' => {
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1_Canis2_5end' => {
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis1_3end' => { 'overThresh' => 0 },
                          'L1_Canis2_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1PA13_5end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1Pt_5end'      => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1P1_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_orf2'   => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PBb_5end'     => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_5end'   => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB_orf2'      => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P1_5end'      => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1MB4_3end' => {
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'L1P4a_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1MC' => {
                'L1MCb_5end'  => { 'overThresh' => 0 },
                'L1MC_orf2'   => { 'overThresh' => 0 },
                'L1ME3_3end'  => { 'overThresh' => 33 },
                'L1ME2z_3end' => { 'overThresh' => 33 },
                'L1MC2_3end'  => { 'overThresh' => 0 },
                'L1MC5_3end'  => { 'overThresh' => 0 },
                'L1ME3A_3end' => { 'overThresh' => 33 },
                'L1MD1_3end'  => { 'overThresh' => 33 },
                'L1MD2_3end'  => { 'overThresh' => 33 },
                'L1ME2_3end'  => { 'overThresh' => 33 },
                'L1MC3_3end'  => { 'overThresh' => 0 },
                'L1ME4a_3end' => { 'overThresh' => 33 },
                'L1MCa_5end'  => { 'overThresh' => 0 },
                'L1ME3B_3end' => { 'overThresh' => 33 },
                'L1ME5_3end'  => { 'overThresh' => 33 },
                'L1MC4_3endX' => { 'overThresh' => 0 },
                'L1MC4a_3end' => { 'overThresh' => 0 },
                'L1MC1_3end'  => { 'overThresh' => 0 },
                'L1ME1_3end'  => { 'overThresh' => 33 },
                'L1MC4_3end'  => { 'overThresh' => 0 },
                'L1MC4_5end'  => { 'overThresh' => 0 },
                'L1MD3_3end'  => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 },
                'L1MCc_5end'  => { 'overThresh' => 0 }
    },
    'Lx4A_3end' => {
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1MA9_3end' => {
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'L1MB7_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1MB8_3end'  => { 'overThresh' => 0 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 0 }
    },
    'L1_Opos3_3end' => { 'L1_Opos3_orf2' => { 'overThresh' => 0 } },
    'L1Pt_3end'     => {
                     'L1PREC2_orf2' => { 'overThresh' => 0 },
                     'L1PREC2_5end' => { 'overThresh' => 0 },
                     'L1P1_5end'    => { 'overThresh' => 0 },
                     'L1P'          => { 'overThresh' => 0 },
                     'L1P1'         => { 'overThresh' => 0 },
                     'L1Pt_5end'    => { 'overThresh' => 0 },
                     'L1P1_orf2'    => { 'overThresh' => 0 }
    },
    'L1P4_orf2' => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1PB2_3end'     => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1PA14_3end'    => { 'overThresh' => 0 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1PA13_3end'    => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1P3_orf2'      => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1PA10_3end'    => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1PA12_3end'    => { 'overThresh' => 0 },
                     'L1P3'           => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1PA16_3end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1PA11_3end'    => { 'overThresh' => 0 },
                     'L1P5'           => { 'overThresh' => 0 },
                     'L1PA15_3end'    => { 'overThresh' => 0 },
                     'L1P4'           => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1PB3_3end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 },
                     'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1_RS1_3end' => {
                       'L1_RS1_orf2' => { 'overThresh' => 0 },
                       'L1_RS1_5end' => { 'overThresh' => 0 }
    },
    'L1_Rn2_3end' => {
                       'L1_Rn_5end'   => { 'overThresh' => 0 },
                       'L1_Rat1_3end' => { 'overThresh' => 33 },
                       'L1_Rat2_3end' => { 'overThresh' => 33 },
                       'L1_Rn_orf2'   => { 'overThresh' => 0 },
                       'L1_Rat4_3end' => { 'overThresh' => 33 },
                       'L1_Rat3_3end' => { 'overThresh' => 33 },
                       'L1_Rn_3end'   => { 'overThresh' => 0 }
    },
    'L1PA7_3end' => {
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1P1'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA3_3end'     => { 'overThresh' => 33 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1PA2_3end'     => { 'overThresh' => 33 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA4_3end'     => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PA5_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1ME3_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 33 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3endX' => { 'overThresh' => 33 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 33 },
                      'L1MC'        => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 33 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1MB2_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'L1P3b_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 0 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1MD2_3end' => {
                      'L1MD'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MD1_3end'  => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 33 },
                      'L1MC4_3endX' => { 'overThresh' => 33 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC'        => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 33 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 33 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Canis4_3end' => {
                          'L1_Carn2_5end'  => { 'overThresh' => 0 },
                          'L1_Carn1_5end'  => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis5_5end' => { 'overThresh' => 0 },
                          'L1_Canis4_orf2' => { 'overThresh' => 0 },
                          'L1_Carn2_orf2'  => { 'overThresh' => 0 },
                          'L1_Canis4_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1_Opos_orf2' => { 'L1_Opos' => { 'overThresh' => 0 } },
    'L1PA2_3end'   => {
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1P1'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 33 },
                      'L1PA12_5end'    => { 'overThresh' => 33 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 33 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA3_3end'     => { 'overThresh' => 0 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PA4_3end'     => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 33 },
                      'L1PA5_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 33 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1Md_T_3end' => {
                       'L1Md_A_5end'  => { 'overThresh' => 33 },
                       'L1Md_F_5end'  => { 'overThresh' => 33 },
                       'L1Md_Gf_5end' => { 'overThresh' => 33 },
                       'L1_Mus1_3end' => { 'overThresh' => 33 },
                       'L1_Mus3_3end' => { 'overThresh' => 33 },
                       'L1_Mm_orf2'   => { 'overThresh' => 0 },
                       'L1_Mus2_3end' => { 'overThresh' => 33 },
                       'L1_Mus4_3end' => { 'overThresh' => 33 },
                       'L1Md_A_3end'  => { 'overThresh' => 33 },
                       'L1Md_F3_3end' => { 'overThresh' => 33 },
                       'L1Md_F2_3end' => { 'overThresh' => 33 }
    },
    'L1MEd_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'ATLINE1_10' => {
                      'ATLINE1_1'   => { 'overThresh' => 0 },
                      'ATLINE1_10A' => { 'overThresh' => 0 }
    },
    'L1_Carn1_5end' => {
                         'L1_Carn2_5end'  => { 'overThresh' => 0 },
                         'L1_Canis5_5end' => { 'overThresh' => 0 },
                         'L1_Canis4_3end' => { 'overThresh' => 0 },
                         'L1_Carn2_3end'  => { 'overThresh' => 0 },
                         'L1_Canis4_orf2' => { 'overThresh' => 0 },
                         'L1_Canis4_5end' => { 'overThresh' => 0 },
                         'L1_Carn2_orf2'  => { 'overThresh' => 0 }
    },
    'L1_Opos3_orf2' => {
                         'L1_Opos3_3end' => { 'overThresh' => 0 },
                         'L1_Opos'       => { 'overThresh' => 0 },
                         'L1_Opos2_3end' => { 'overThresh' => 0 }
    },
    'L1P1' => {
                'L1Pt_3end'    => { 'overThresh' => 0 },
                'L1PREC2_5end' => { 'overThresh' => 0 },
                'L1HS_5end'    => { 'overThresh' => 0 },
                'L1PA7_3end'   => { 'overThresh' => 0 },
                'L1P'          => { 'overThresh' => 0 },
                'L1P2'         => { 'overThresh' => 0 },
                'L1P2_5end'    => { 'overThresh' => 0 },
                'L1P1_orf2'    => { 'overThresh' => 0 },
                'L1PA3_3end'   => { 'overThresh' => 0 },
                'L1PA6_3end'   => { 'overThresh' => 0 },
                'L1Pt_5end'    => { 'overThresh' => 0 },
                'L1PA2_3end'   => { 'overThresh' => 0 },
                'L1PREC2_orf2' => { 'overThresh' => 0 },
                'L1PA4_3end'   => { 'overThresh' => 0 },
                'L1PA5_3end'   => { 'overThresh' => 0 },
                'L1P1_5end'    => { 'overThresh' => 0 },
                'L1PREC2_3end' => { 'overThresh' => 0 },
                'L1HS_3end'    => { 'overThresh' => 0 }
    },
    'CiL1'       => { 'CiL1.2' => { 'overThresh' => 0 } },
    'L1MD1_3end' => {
                      'L1MD'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 33 },
                      'L1MC4_3endX' => { 'overThresh' => 33 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC'        => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 33 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 33 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1MEg_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Carn7_5end' => {
                         'L1_Carn7_3end' => { 'overThresh' => 0 },
                         'L1_Carn7_orf2' => { 'overThresh' => 0 }
    },
    'L1Md_F3_3end' => {
                        'L1Md_T_3end'  => { 'overThresh' => 33 },
                        'L1Md_A_5end'  => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 0 },
                        'L1Md_Gf_5end' => { 'overThresh' => 33 },
                        'L1_Mus1_3end' => { 'overThresh' => 33 },
                        'L1_Mus3_3end' => { 'overThresh' => 33 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1_Mus2_3end' => { 'overThresh' => 33 },
                        'L1Md_A_3end'  => { 'overThresh' => 33 },
                        'L1_Mus4_3end' => { 'overThresh' => 33 },
                        'L1Md_F2_3end' => { 'overThresh' => 0 }
    },
    'L1MA3_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 33 }
    },
    'Lx5_3end' => {
                    'L1_Mur2_orf2' => { 'overThresh' => 0 },
                    'L1_Mur2_5end' => { 'overThresh' => 0 },
                    'L1_Mur3_5end' => { 'overThresh' => 0 },
                    'L1_Mur3_orf2' => { 'overThresh' => 0 }
    },
    'L1_Mur1_5end' => {
                        'Lx_3end'      => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 0 },
                        'Lx3C_3end'    => { 'overThresh' => 0 },
                        'L1_Mur2_5end' => { 'overThresh' => 0 },
                        'Lx3B_3end'    => { 'overThresh' => 0 },
                        'Lx2_3end'     => { 'overThresh' => 0 },
                        'Lx4B_3end'    => { 'overThresh' => 0 },
                        'Lx2B_3end'    => { 'overThresh' => 0 },
                        'Lx3A_3end'    => { 'overThresh' => 0 },
                        'Lx4A_3end'    => { 'overThresh' => 0 },
                        'L1_Mur2_orf2' => { 'overThresh' => 0 },
                        'Lx3_Mus_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 0 },
                        'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1_Rn_orf2' => {
                      'L1_Rn_5end'   => { 'overThresh' => 0 },
                      'L1_Rat1_3end' => { 'overThresh' => 0 },
                      'Lx_3end'      => { 'overThresh' => 0 },
                      'L1_Rn2_3end'  => { 'overThresh' => 0 },
                      'L1_Rat4_3end' => { 'overThresh' => 0 },
                      'Lx2A_3end'    => { 'overThresh' => 0 },
                      'Lx2_3end'     => { 'overThresh' => 0 },
                      'L1_Rn_3end'   => { 'overThresh' => 0 },
                      'Lx2B_3end'    => { 'overThresh' => 0 },
                      'L1_Rat2_3end' => { 'overThresh' => 0 },
                      'L1_Rat3_3end' => { 'overThresh' => 0 },
                      'Lx2A1_3end'   => { 'overThresh' => 0 }
    },
    'L1PREC2_3end' => {
                        'L1PREC2_orf2' => { 'overThresh' => 0 },
                        'L1PREC2_5end' => { 'overThresh' => 0 },
                        'L1P1_5end'    => { 'overThresh' => 0 },
                        'L1P'          => { 'overThresh' => 0 },
                        'L1P1'         => { 'overThresh' => 0 },
                        'L1Pt_5end'    => { 'overThresh' => 0 },
                        'L1P1_orf2'    => { 'overThresh' => 0 }
    },
    'L1PA10_3end' => {
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1_Canis4_orf2' => {
                          'L1_Carn2_5end'  => { 'overThresh' => 0 },
                          'L1_Carn1_5end'  => { 'overThresh' => 0 },
                          'L1_Canis5_5end' => { 'overThresh' => 0 },
                          'L1_Carn2_3end'  => { 'overThresh' => 0 },
                          'L1_Canis4_3end' => { 'overThresh' => 0 },
                          'L1_Canis4_5end' => { 'overThresh' => 0 },
                          'L1_Carn2_orf2'  => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1_Mur3_5end' => {
                        'Lx5_3end'     => { 'overThresh' => 0 },
                        'Lx6_3end'     => { 'overThresh' => 0 },
                        'Lx7_3end'     => { 'overThresh' => 0 },
                        'Lx8_3end'     => { 'overThresh' => 0 },
                        'L1_Mur2_orf2' => { 'overThresh' => 0 },
                        'L1_Mur2_5end' => { 'overThresh' => 0 },
                        'L1_Mur3_orf2' => { 'overThresh' => 0 }
    },
    'L1MB5_3end' => {
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 0 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'L1_Rod_5end' => {
                       'Lx8_3end' => { 'overThresh' => 0 },
                       'Lx9_3end' => { 'overThresh' => 0 }
    },
    'L1M2_5end' => {
                     'L1M2a1_5end' => { 'overThresh' => 0 },
                     'L1MA6_3end'  => { 'overThresh' => 0 },
                     'L1M1_orf2'   => { 'overThresh' => 0 },
                     'L1M2'        => { 'overThresh' => 0 },
                     'L1M2b_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1MA4A_3end' => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1MA4_3end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MA5A_3end' => { 'overThresh' => 0 },
                     'L1MA8_3end'  => { 'overThresh' => 0 },
                     'L1M1_5end'   => { 'overThresh' => 0 },
                     'L1M2a_5end'  => { 'overThresh' => 0 },
                     'L1M1'        => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1MA5_3end'  => { 'overThresh' => 0 },
                     'L1M3_orf2'   => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1M3'        => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MA9_3end'  => { 'overThresh' => 0 },
                     'L1M2_orf2'   => { 'overThresh' => 0 },
                     'L1M2c_5end'  => { 'overThresh' => 0 },
                     'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'L1_Canis0_5end' => {
                          'L1_Canis2_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis1_3end' => { 'overThresh' => 0 },
                          'L1_Canis5_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_3end' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis4_3end' => { 'overThresh' => 0 },
                          'L1_Canis4_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1_Carn7_3end' => {
                         'L1_Carn7_5end' => { 'overThresh' => 0 },
                         'L1_Carn7_orf2' => { 'overThresh' => 0 }
    },
    'L1PA15_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 33 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PBb_5end'     => { 'overThresh' => 33 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PB4_3end'     => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 33 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 33 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 33 },
                       'L1PB1_3end'     => { 'overThresh' => 33 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1M4c_5end' => {
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MB7_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Mdo1_5end' => {
                        'L1_Mdo1_3end' => { 'overThresh' => 0 },
                        'L1_Mdo1_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_5end' => { 'overThresh' => 0 },
                        'L1_Mdo2_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_3end' => { 'overThresh' => 0 }
    },
    'L1Md_F_5end' => {
                       'L1Md_T_3end'  => { 'overThresh' => 0 },
                       'L1Md_A_5end'  => { 'overThresh' => 0 },
                       'L1_Mus1_3end' => { 'overThresh' => 33 },
                       'L1_Mus3_3end' => { 'overThresh' => 33 },
                       'L1Md_Gf_5end' => { 'overThresh' => 0 },
                       'L1_Mm_orf2'   => { 'overThresh' => 0 },
                       'L1_Mus2_3end' => { 'overThresh' => 33 },
                       'L1_Mus4_3end' => { 'overThresh' => 33 },
                       'L1Md_A_3end'  => { 'overThresh' => 0 },
                       'L1Md_F3_3end' => { 'overThresh' => 0 },
                       'L1Md_F2_3end' => { 'overThresh' => 0 }
    },
    'L1_Carn2_5end' => {
                         'L1_Carn3_3end'  => { 'overThresh' => 0 },
                         'L1_Carn3_5end'  => { 'overThresh' => 0 },
                         'L1_Canis5_5end' => { 'overThresh' => 0 },
                         'L1_Carn2_3end'  => { 'overThresh' => 0 },
                         'L1_Canis4_5end' => { 'overThresh' => 0 },
                         'L1_Carn2_orf2'  => { 'overThresh' => 0 },
                         'L1_Carn1_5end'  => { 'overThresh' => 0 },
                         'L1_Canis4_3end' => { 'overThresh' => 0 },
                         'L1_Canis4_orf2' => { 'overThresh' => 0 }
    },
    'L1M4_orf2' => {
                     'L1M5'        => { 'overThresh' => 0 },
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1MC5_3end'  => { 'overThresh' => 0 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1MB8_3end'  => { 'overThresh' => 0 },
                     'L1MC4_3endX' => { 'overThresh' => 0 },
                     'L1MB4_3end'  => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1M5_orf2'   => { 'overThresh' => 0 },
                     'L1M4'        => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1M3_orf2'   => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1MC4_3end'  => { 'overThresh' => 0 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MB5_3end'  => { 'overThresh' => 0 },
                     'L1MB7_3end'  => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 },
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1MB4_5end'  => { 'overThresh' => 0 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1MC3_3end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1MEb_5end'  => { 'overThresh' => 0 },
                     'L1MC4a_3end' => { 'overThresh' => 0 },
                     'L1ME1_3end'  => { 'overThresh' => 0 },
                     'L1MD3_3end'  => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1M3'        => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1ME1_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 33 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3endX' => { 'overThresh' => 33 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 33 },
                      'L1MC'        => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 33 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'HAL1_Opos1_5end' => {
                           'L1_Opos0_3end'   => { 'overThresh' => 0 },
                           'L1_Opos'         => { 'overThresh' => 0 },
                           'HAL1_Opos1_3end' => { 'overThresh' => 0 },
                           'L1_Opos2_3end'   => { 'overThresh' => 0 },
                           'HAL1'            => { 'overThresh' => 0 },
                           'L1_Opos1_3end'   => { 'overThresh' => 0 }
    },
    'TX1_FR1'    => { 'TX1' => { 'overThresh' => 0 } },
    'L1P4d_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1MDb_5end' => {
                      'L1MD'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 }
    },
    'L1MD' => {
                'L1MD2_5end'  => { 'overThresh' => 0 },
                'L1ME3_3end'  => { 'overThresh' => 33 },
                'L1MDa_5end'  => { 'overThresh' => 0 },
                'L1ME2z_3end' => { 'overThresh' => 33 },
                'L1MC5_3end'  => { 'overThresh' => 33 },
                'L1MC2_3end'  => { 'overThresh' => 33 },
                'L1ME3A_3end' => { 'overThresh' => 33 },
                'L1MD1_3end'  => { 'overThresh' => 0 },
                'L1MD2_3end'  => { 'overThresh' => 0 },
                'L1ME2_3end'  => { 'overThresh' => 33 },
                'L1MC3_3end'  => { 'overThresh' => 33 },
                'L1ME4a_3end' => { 'overThresh' => 33 },
                'L1ME3B_3end' => { 'overThresh' => 33 },
                'L1ME5_3end'  => { 'overThresh' => 33 },
                'L1MC4a_3end' => { 'overThresh' => 33 },
                'L1MD_orf2'   => { 'overThresh' => 0 },
                'L1MC1_3end'  => { 'overThresh' => 33 },
                'L1ME1_3end'  => { 'overThresh' => 33 },
                'L1MC4_3end'  => { 'overThresh' => 33 },
                'L1MD3_3end'  => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 },
                'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1M5' => {
                'L1ME3_3end'  => { 'overThresh' => 0 },
                'L1ME2z_3end' => { 'overThresh' => 0 },
                'L1MC5_3end'  => { 'overThresh' => 0 },
                'L1ME3A_3end' => { 'overThresh' => 0 },
                'L1M6_5end'   => { 'overThresh' => 0 },
                'L1ME2_3end'  => { 'overThresh' => 0 },
                'L1MC3_3end'  => { 'overThresh' => 0 },
                'L1ME4a_3end' => { 'overThresh' => 0 },
                'L1ME3B_3end' => { 'overThresh' => 0 },
                'L1M7_5end'   => { 'overThresh' => 0 },
                'L1M4c_5end'  => { 'overThresh' => 0 },
                'L1MC4_3endX' => { 'overThresh' => 0 },
                'L1M4_5end'   => { 'overThresh' => 0 },
                'L1MC4a_3end' => { 'overThresh' => 0 },
                'L1M4b_5end'  => { 'overThresh' => 0 },
                'L1M5_orf2'   => { 'overThresh' => 0 },
                'L1M4'        => { 'overThresh' => 0 },
                'L1ME1_3end'  => { 'overThresh' => 0 },
                'L1M4_orf2'   => { 'overThresh' => 0 },
                'L1MD3_3end'  => { 'overThresh' => 0 },
                'L1MC4_5end'  => { 'overThresh' => 0 },
                'L1MC4_3end'  => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 }
    },
    'L1_Mdo4_3end' => {
                        'L1_Mdo4_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo5_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo4_5end' => { 'overThresh' => 0 },
                        'L1_Mdo5_5end' => { 'overThresh' => 0 }
    },
    'L1_Mars1_orf2' => { 'L1_Mars1_5end' => { 'overThresh' => 0 } },
    'Lx2_3end'      => {
                    'L1_Rat1_3end' => { 'overThresh' => 33 },
                    'L1_Rat4_3end' => { 'overThresh' => 33 },
                    'L1_Mur2_5end' => { 'overThresh' => 0 },
                    'L1_Mus3_3end' => { 'overThresh' => 33 },
                    'L1_Mus1_3end' => { 'overThresh' => 33 },
                    'L1_Mur1_5end' => { 'overThresh' => 0 },
                    'L1_Rat2_3end' => { 'overThresh' => 33 },
                    'L1_Rn_orf2'   => { 'overThresh' => 0 },
                    'L1_Mus2_3end' => { 'overThresh' => 33 },
                    'L1_Mm_orf2'   => { 'overThresh' => 0 },
                    'L1_Mur2_orf2' => { 'overThresh' => 0 },
                    'L1_Rat3_3end' => { 'overThresh' => 33 },
                    'L1_Mus4_3end' => { 'overThresh' => 33 },
                    'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1MC2_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1M3b_5end' => {
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'L1M3d_5end' => {
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'HAL1-2a_MD' => { 'HAL1' => { 'overThresh' => 0 } },
    'ATLINE1_1'  => {
                     'ATLINE1_10A' => { 'overThresh' => 0 },
                     'ATLINE1_11'  => { 'overThresh' => 0 },
                     'ATLINE1_12'  => { 'overThresh' => 0 },
                     'ATLINE1_10'  => { 'overThresh' => 0 }
    },
    'L1MCa_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Mdo2_3end' => {
                        'L1_Mdo1_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_5end' => { 'overThresh' => 0 },
                        'L1_Mdo2_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo1_5end' => { 'overThresh' => 0 }
    },
    'L1MA5A_3end' => {
                       'L1MA6_3end'  => { 'overThresh' => 0 },
                       'L1M2a1_5end' => { 'overThresh' => 0 },
                       'L1M1_orf2'   => { 'overThresh' => 0 },
                       'L1M2'        => { 'overThresh' => 0 },
                       'L1M2b_5end'  => { 'overThresh' => 0 },
                       'L1MB2_3end'  => { 'overThresh' => 33 },
                       'L1MB4_5end'  => { 'overThresh' => 33 },
                       'L1MA4A_3end' => { 'overThresh' => 0 },
                       'L1M2_5end'   => { 'overThresh' => 0 },
                       'L1MA2_3end'  => { 'overThresh' => 33 },
                       'L1MA4_3end'  => { 'overThresh' => 0 },
                       'L1MB8_3end'  => { 'overThresh' => 33 },
                       'L1MA3_3end'  => { 'overThresh' => 33 },
                       'L1M2a_5end'  => { 'overThresh' => 0 },
                       'L1M1_5end'   => { 'overThresh' => 0 },
                       'L1MA8_3end'  => { 'overThresh' => 0 },
                       'L1MB4_3end'  => { 'overThresh' => 33 },
                       'L1M1'        => { 'overThresh' => 0 },
                       'L1MB1_3end'  => { 'overThresh' => 33 },
                       'L1MA5_3end'  => { 'overThresh' => 0 },
                       'L1MA10_3end' => { 'overThresh' => 33 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1M2_orf2'   => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MB3_3end'  => { 'overThresh' => 33 },
                       'L1M2c_5end'  => { 'overThresh' => 0 },
                       'L1MA7_3end'  => { 'overThresh' => 0 },
                       'L1MB7_3end'  => { 'overThresh' => 33 },
                       'L1MA1_3end'  => { 'overThresh' => 33 },
                       'L1MB5_3end'  => { 'overThresh' => 33 }
    },
    'L1MC4_3endX' => {
                       'L1M5'        => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 0 },
                       'L1ME3_3end'  => { 'overThresh' => 33 },
                       'L1MC_orf2'   => { 'overThresh' => 0 },
                       'L1ME2z_3end' => { 'overThresh' => 33 },
                       'L1MC5_3end'  => { 'overThresh' => 0 },
                       'L1MC2_3end'  => { 'overThresh' => 0 },
                       'L1ME3A_3end' => { 'overThresh' => 33 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1ME2_3end'  => { 'overThresh' => 33 },
                       'L1MC3_3end'  => { 'overThresh' => 0 },
                       'L1ME4a_3end' => { 'overThresh' => 33 },
                       'L1MCa_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 33 },
                       'L1M4c_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 33 },
                       'L1M4_5end'   => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 0 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1M4b_5end'  => { 'overThresh' => 0 },
                       'L1M4'        => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 0 },
                       'L1M4_orf2'   => { 'overThresh' => 0 },
                       'L1ME1_3end'  => { 'overThresh' => 33 },
                       'L1MC'        => { 'overThresh' => 0 },
                       'L1MC4_3end'  => { 'overThresh' => 0 },
                       'L1MC4_5end'  => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 0 }
    },
    'L1_Canis4_5end' => {
                          'L1_Canis5_5end' => { 'overThresh' => 0 },
                          'L1_Carn2_3end'  => { 'overThresh' => 0 },
                          'L1_Carn2_orf2'  => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 },
                          'L1_Carn2_5end'  => { 'overThresh' => 0 },
                          'L1_Carn1_5end'  => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis4_orf2' => { 'overThresh' => 0 },
                          'L1_Canis4_3end' => { 'overThresh' => 0 }
    },
    'TX1' => {
               'TX1_FR2' => { 'overThresh' => 0 },
               'TX1_FR1' => { 'overThresh' => 0 }
    },
    'L1PBb_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PB4_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1PB1_3end'     => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1M3f_5end' => {
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'L1M3c_5end' => {
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'L1M3_orf2' => {
                     'L1M2a1_5end' => { 'overThresh' => 0 },
                     'L1M2'        => { 'overThresh' => 0 },
                     'L1M2b_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1MB4_5end'  => { 'overThresh' => 0 },
                     'L1MB2_3end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1M2_5end'   => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1M2a_5end'  => { 'overThresh' => 0 },
                     'L1MA8_3end'  => { 'overThresh' => 0 },
                     'L1M1_5end'   => { 'overThresh' => 0 },
                     'L1MB4_3end'  => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1M4'        => { 'overThresh' => 0 },
                     'L1MB1_3end'  => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1M4_orf2'   => { 'overThresh' => 0 },
                     'L1MA10_3end' => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1M2_orf2'   => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MA9_3end'  => { 'overThresh' => 0 },
                     'L1M3'        => { 'overThresh' => 0 },
                     'L1MB3_3end'  => { 'overThresh' => 0 },
                     'L1M2c_5end'  => { 'overThresh' => 0 },
                     'L1MB5_3end'  => { 'overThresh' => 0 }
    },
    'L1M' => {
               'L1M1_orf2'   => { 'overThresh' => 0 },
               'L1M2'        => { 'overThresh' => 0 },
               'L1MD2_5end'  => { 'overThresh' => 0 },
               'L1ME2z_3end' => { 'overThresh' => 0 },
               'L1M3e_5end'  => { 'overThresh' => 0 },
               'L1MD1_3end'  => { 'overThresh' => 0 },
               'L1MEg_5end'  => { 'overThresh' => 0 },
               'L1ME3B_3end' => { 'overThresh' => 0 },
               'L1M7_5end'   => { 'overThresh' => 0 },
               'L1MB8_3end'  => { 'overThresh' => 0 },
               'L1MA3_3end'  => { 'overThresh' => 0 },
               'L1MA8_3end'  => { 'overThresh' => 0 },
               'L1M1_5end'   => { 'overThresh' => 0 },
               'L1MD_orf2'   => { 'overThresh' => 0 },
               'L1M5_orf2'   => { 'overThresh' => 0 },
               'L1M4'        => { 'overThresh' => 0 },
               'L1MB1_3end'  => { 'overThresh' => 0 },
               'L1MC4_3end'  => { 'overThresh' => 0 },
               'L1MC4_5end'  => { 'overThresh' => 0 },
               'L1MB5_3end'  => { 'overThresh' => 0 },
               'L1M2b_5end'  => { 'overThresh' => 0 },
               'L1M3a_5end'  => { 'overThresh' => 0 },
               'L1MB4_5end'  => { 'overThresh' => 0 },
               'L1ME3A_3end' => { 'overThresh' => 0 },
               'L1MA4A_3end' => { 'overThresh' => 0 },
               'L1M2_5end'   => { 'overThresh' => 0 },
               'L1MEg1_5end' => { 'overThresh' => 0 },
               'L1MC3_3end'  => { 'overThresh' => 0 },
               'L1ME4a_3end' => { 'overThresh' => 0 },
               'L1MEc_5end'  => { 'overThresh' => 0 },
               'L1M4c_5end'  => { 'overThresh' => 0 },
               'L1MA4_3end'  => { 'overThresh' => 0 },
               'L1ME5_3end'  => { 'overThresh' => 0 },
               'L1M2a_5end'  => { 'overThresh' => 0 },
               'L1M4_orf2'   => { 'overThresh' => 0 },
               'L1ME1_3end'  => { 'overThresh' => 0 },
               'L1MD3_3end'  => { 'overThresh' => 0 },
               'L1M3'        => { 'overThresh' => 0 },
               'L1M2c_5end'  => { 'overThresh' => 0 },
               'L1MB3_3end'  => { 'overThresh' => 0 },
               'L1MDb_5end'  => { 'overThresh' => 0 },
               'L1MD'        => { 'overThresh' => 0 },
               'L1M5'        => { 'overThresh' => 0 },
               'L1MC2_3end'  => { 'overThresh' => 0 },
               'L1MC5_3end'  => { 'overThresh' => 0 },
               'L1M6_5end'   => { 'overThresh' => 0 },
               'L1MEf_5end'  => { 'overThresh' => 0 },
               'L1M3b_5end'  => { 'overThresh' => 0 },
               'L1MA2_3end'  => { 'overThresh' => 0 },
               'L1M3d_5end'  => { 'overThresh' => 0 },
               'L1MCa_5end'  => { 'overThresh' => 0 },
               'L1MA5A_3end' => { 'overThresh' => 0 },
               'L1MC4_3endX' => { 'overThresh' => 0 },
               'L1MB4_3end'  => { 'overThresh' => 0 },
               'L1M4_5end'   => { 'overThresh' => 0 },
               'L1M4b_5end'  => { 'overThresh' => 0 },
               'L1MC1_3end'  => { 'overThresh' => 0 },
               'L1M3c_5end'  => { 'overThresh' => 0 },
               'L1M3_orf2'   => { 'overThresh' => 0 },
               'L1M3f_5end'  => { 'overThresh' => 0 },
               'L1MA5_3end'  => { 'overThresh' => 0 },
               'L1MA10_3end' => { 'overThresh' => 0 },
               'L1MC'        => { 'overThresh' => 0 },
               'L1M2_orf2'   => { 'overThresh' => 0 },
               'L1MA9_3end'  => { 'overThresh' => 0 },
               'L1MA7_3end'  => { 'overThresh' => 0 },
               'L1MCc_5end'  => { 'overThresh' => 0 },
               'L1MB7_3end'  => { 'overThresh' => 0 },
               'L1MA6_3end'  => { 'overThresh' => 0 },
               'L1M2a1_5end' => { 'overThresh' => 0 },
               'L1MEa_5end'  => { 'overThresh' => 0 },
               'L1MCb_5end'  => { 'overThresh' => 0 },
               'L1MC_orf2'   => { 'overThresh' => 0 },
               'L1ME3_3end'  => { 'overThresh' => 0 },
               'L1MEg2_5end' => { 'overThresh' => 0 },
               'L1MB2_3end'  => { 'overThresh' => 0 },
               'L1MDa_5end'  => { 'overThresh' => 0 },
               'L1MEe_5end'  => { 'overThresh' => 0 },
               'L1MD2_3end'  => { 'overThresh' => 0 },
               'L1ME2_3end'  => { 'overThresh' => 0 },
               'L1MEd_5end'  => { 'overThresh' => 0 },
               'L1MEb_5end'  => { 'overThresh' => 0 },
               'L1M1'        => { 'overThresh' => 0 },
               'L1MC4a_3end' => { 'overThresh' => 0 },
               'L1M3de_5end' => { 'overThresh' => 0 },
               'L1MA1_3end'  => { 'overThresh' => 0 }
    },
    'L1Md_F2_3end' => {
                        'L1Md_T_3end'  => { 'overThresh' => 33 },
                        'L1Md_A_5end'  => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 0 },
                        'L1Md_Gf_5end' => { 'overThresh' => 33 },
                        'L1_Mus1_3end' => { 'overThresh' => 33 },
                        'L1_Mus3_3end' => { 'overThresh' => 33 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1_Mus2_3end' => { 'overThresh' => 33 },
                        'L1Md_A_3end'  => { 'overThresh' => 33 },
                        'L1_Mus4_3end' => { 'overThresh' => 33 },
                        'L1Md_F3_3end' => { 'overThresh' => 0 }
    },
    'L1PREC2_5end' => {
                        'L1P4c_5end'     => { 'overThresh' => 0 },
                        'L1Pt_3end'      => { 'overThresh' => 0 },
                        'L1P4_orf2'      => { 'overThresh' => 0 },
                        'L1P3_5end'      => { 'overThresh' => 0 },
                        'L1P'            => { 'overThresh' => 0 },
                        'L1P1'           => { 'overThresh' => 0 },
                        'L1PA14_5end'    => { 'overThresh' => 0 },
                        'L1P3'           => { 'overThresh' => 0 },
                        'L1PA12_5end'    => { 'overThresh' => 0 },
                        'L1PBa_5end'     => { 'overThresh' => 0 },
                        'L1PA17_5end'    => { 'overThresh' => 0 },
                        'L1P3b_5end'     => { 'overThresh' => 0 },
                        'L1P2_5end'      => { 'overThresh' => 0 },
                        'L1P2'           => { 'overThresh' => 0 },
                        'L1P5'           => { 'overThresh' => 0 },
                        'L1Pt_5end'      => { 'overThresh' => 0 },
                        'L1P1_orf2'      => { 'overThresh' => 0 },
                        'L1PREC2_orf2'   => { 'overThresh' => 0 },
                        'L1PB_orf2'      => { 'overThresh' => 0 },
                        'L1P4'           => { 'overThresh' => 0 },
                        'L1P3_orf2'      => { 'overThresh' => 0 },
                        'L1PBa1_5end'    => { 'overThresh' => 0 },
                        'L1PA13_5end'    => { 'overThresh' => 0 },
                        'L1PA10_5end'    => { 'overThresh' => 0 },
                        'L1PA15-16_5end' => { 'overThresh' => 0 },
                        'L1PBb_5end'     => { 'overThresh' => 0 },
                        'L1P4a_5end'     => { 'overThresh' => 0 },
                        'L1P4e_5end'     => { 'overThresh' => 0 },
                        'L1P4b_5end'     => { 'overThresh' => 0 },
                        'L1P1_5end'      => { 'overThresh' => 0 },
                        'L1PREC2_3end'   => { 'overThresh' => 0 },
                        'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1MA6_3end' => {
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 }
    },
    'L1M2a1_5end' => {
                       'L1MA6_3end'  => { 'overThresh' => 0 },
                       'L1M1_orf2'   => { 'overThresh' => 0 },
                       'L1M2'        => { 'overThresh' => 0 },
                       'L1M2b_5end'  => { 'overThresh' => 0 },
                       'L1M3a_5end'  => { 'overThresh' => 0 },
                       'L1M3e_5end'  => { 'overThresh' => 0 },
                       'L1MA4A_3end' => { 'overThresh' => 0 },
                       'L1M2_5end'   => { 'overThresh' => 0 },
                       'L1M3b_5end'  => { 'overThresh' => 0 },
                       'L1M3d_5end'  => { 'overThresh' => 0 },
                       'L1MA4_3end'  => { 'overThresh' => 0 },
                       'L1M4c_5end'  => { 'overThresh' => 0 },
                       'L1MA5A_3end' => { 'overThresh' => 0 },
                       'L1MA8_3end'  => { 'overThresh' => 0 },
                       'L1M1_5end'   => { 'overThresh' => 0 },
                       'L1M2a_5end'  => { 'overThresh' => 0 },
                       'L1M1'        => { 'overThresh' => 0 },
                       'L1M4_5end'   => { 'overThresh' => 0 },
                       'L1M4b_5end'  => { 'overThresh' => 0 },
                       'L1M3f_5end'  => { 'overThresh' => 0 },
                       'L1M3c_5end'  => { 'overThresh' => 0 },
                       'L1MA5_3end'  => { 'overThresh' => 0 },
                       'L1M3_orf2'   => { 'overThresh' => 0 },
                       'L1M3de_5end' => { 'overThresh' => 0 },
                       'L1M3'        => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1M2_orf2'   => { 'overThresh' => 0 },
                       'L1M2c_5end'  => { 'overThresh' => 0 },
                       'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'L1MEa_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1HS_5end' => {
                     'L1P1_5end' => { 'overThresh' => 0 },
                     'L1P1'      => { 'overThresh' => 0 },
                     'L1P1_orf2' => { 'overThresh' => 0 }
    },
    'L1P3_5end' => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1P2'           => { 'overThresh' => 0 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1PA8_3end'     => { 'overThresh' => 0 },
                     'L1PA13_3end'    => { 'overThresh' => 0 },
                     'L1PA6_3end'     => { 'overThresh' => 0 },
                     'L1P1_orf2'      => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1P3_orf2'      => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1PA10_3end'    => { 'overThresh' => 0 },
                     'L1P4_orf2'      => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1PA7_3end'     => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1P3'           => { 'overThresh' => 0 },
                     'L1PA12_3end'    => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1PA8A_3end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1PA11_3end'    => { 'overThresh' => 0 },
                     'L1PB_orf2'      => { 'overThresh' => 0 },
                     'L1P4'           => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1MEg2_5end' => {
                       'L1MD2_5end'  => { 'overThresh' => 0 },
                       'L1ME2z_3end' => { 'overThresh' => 0 },
                       'L1MC5_3end'  => { 'overThresh' => 33 },
                       'L1MC2_3end'  => { 'overThresh' => 33 },
                       'L1M6_5end'   => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 0 },
                       'L1MEg_5end'  => { 'overThresh' => 0 },
                       'L1MCa_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 0 },
                       'L1M7_5end'   => { 'overThresh' => 0 },
                       'L1MD_orf2'   => { 'overThresh' => 0 },
                       'L1M4_5end'   => { 'overThresh' => 0 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1M4b_5end'  => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 33 },
                       'L1MC4_5end'  => { 'overThresh' => 0 },
                       'L1MC4_3end'  => { 'overThresh' => 33 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 0 },
                       'L1MEa_5end'  => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 0 },
                       'L1MC_orf2'   => { 'overThresh' => 0 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1MDa_5end'  => { 'overThresh' => 0 },
                       'L1ME3A_3end' => { 'overThresh' => 0 },
                       'L1MEe_5end'  => { 'overThresh' => 0 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1MEg1_5end' => { 'overThresh' => 0 },
                       'L1MC3_3end'  => { 'overThresh' => 33 },
                       'L1ME4a_3end' => { 'overThresh' => 0 },
                       'L1MEc_5end'  => { 'overThresh' => 0 },
                       'L1MEd_5end'  => { 'overThresh' => 0 },
                       'L1M4c_5end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1M4_orf2'   => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 33 },
                       'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1PA12_5end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1Pt_5end'      => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1P1_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_orf2'   => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PBb_5end'     => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_5end'   => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB_orf2'      => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P1_5end'      => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1MDa_5end' => {
                      'L1MD'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1MEe_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1ME2_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 33 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3endX' => { 'overThresh' => 33 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 33 },
                      'L1MC'        => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 33 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'RNHAL1_5end' => { 'RNHAL1' => { 'overThresh' => 0 } },
    'L1P5'        => {
                'L1P4_orf2'    => { 'overThresh' => 0 },
                'L1P4c_5end'   => { 'overThresh' => 0 },
                'L1PB2_3end'   => { 'overThresh' => 0 },
                'L1PREC2_5end' => { 'overThresh' => 0 },
                'L1P'          => { 'overThresh' => 0 },
                'L1PBa_5end'   => { 'overThresh' => 0 },
                'L1Pt_5end'    => { 'overThresh' => 0 },
                'L1PREC2_orf2' => { 'overThresh' => 0 },
                'L1PB4_3end'   => { 'overThresh' => 0 },
                'L1PB_orf2'    => { 'overThresh' => 0 },
                'L1P4'         => { 'overThresh' => 0 },
                'L1PBa1_5end'  => { 'overThresh' => 0 },
                'L1PBb_5end'   => { 'overThresh' => 0 },
                'L1P4a_5end'   => { 'overThresh' => 0 },
                'L1P4e_5end'   => { 'overThresh' => 0 },
                'L1PB3_3end'   => { 'overThresh' => 0 },
                'L1P4b_5end'   => { 'overThresh' => 0 },
                'L1PB1_3end'   => { 'overThresh' => 0 },
                'L1P4d_5end'   => { 'overThresh' => 0 }
    },
    'Lx2A1_3end' => {
                      'L1_Rat1_3end' => { 'overThresh' => 33 },
                      'L1_Rat4_3end' => { 'overThresh' => 33 },
                      'L1_Mur2_5end' => { 'overThresh' => 0 },
                      'L1_Mus3_3end' => { 'overThresh' => 33 },
                      'L1_Mus1_3end' => { 'overThresh' => 33 },
                      'L1_Mur1_5end' => { 'overThresh' => 0 },
                      'L1_Rat2_3end' => { 'overThresh' => 33 },
                      'L1_Rn_orf2'   => { 'overThresh' => 0 },
                      'L1_Mus2_3end' => { 'overThresh' => 33 },
                      'L1_Mm_orf2'   => { 'overThresh' => 0 },
                      'L1_Mur2_orf2' => { 'overThresh' => 0 },
                      'L1_Rat3_3end' => { 'overThresh' => 33 },
                      'L1_Mus4_3end' => { 'overThresh' => 33 },
                      'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'Lx_3end' => {
                   'L1_Rat1_3end' => { 'overThresh' => 33 },
                   'L1_Rat4_3end' => { 'overThresh' => 33 },
                   'L1_Mus3_3end' => { 'overThresh' => 33 },
                   'L1_Mus1_3end' => { 'overThresh' => 33 },
                   'L1_Mur1_5end' => { 'overThresh' => 0 },
                   'L1_Rn_orf2'   => { 'overThresh' => 0 },
                   'L1_Rat2_3end' => { 'overThresh' => 33 },
                   'L1_Mus2_3end' => { 'overThresh' => 33 },
                   'L1_Mm_orf2'   => { 'overThresh' => 0 },
                   'L1_Rat3_3end' => { 'overThresh' => 33 },
                   'L1_Mus4_3end' => { 'overThresh' => 33 },
                   'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1_Opos0_3end' => { 'HAL1_Opos1_5end' => { 'overThresh' => 0 } },
    'ATLINE1_12'    => { 'ATLINE1_1'       => { 'overThresh' => 0 } },
    'L1P1_5end'     => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1P1'           => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1P2'           => { 'overThresh' => 0 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1PA3_3end'     => { 'overThresh' => 0 },
                     'L1P1_orf2'      => { 'overThresh' => 0 },
                     'L1PA6_3end'     => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1P3_orf2'      => { 'overThresh' => 0 },
                     'L1PA4_3end'     => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PA5_3end'     => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1PREC2_3end'   => { 'overThresh' => 0 },
                     'L1HS_3end'      => { 'overThresh' => 0 },
                     'L1P4_orf2'      => { 'overThresh' => 0 },
                     'L1Pt_3end'      => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1HS_5end'      => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1PA7_3end'     => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1PA2_3end'     => { 'overThresh' => 0 },
                     'L1PB_orf2'      => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1_Mur2_orf2' => {
                        'L1_Mur2_5end' => { 'overThresh' => 0 },
                        'L1_Mur3_orf2' => { 'overThresh' => 0 },
                        'Lx2_3end'     => { 'overThresh' => 0 },
                        'Lx2B_3end'    => { 'overThresh' => 0 },
                        'Lx3A_3end'    => { 'overThresh' => 0 },
                        'Lx3_Mus_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 0 },
                        'Lx3C_3end'    => { 'overThresh' => 0 },
                        'Lx3B_3end'    => { 'overThresh' => 0 },
                        'Lx4B_3end'    => { 'overThresh' => 0 },
                        'Lx5_3end'     => { 'overThresh' => 0 },
                        'L1_Mur1_5end' => { 'overThresh' => 0 },
                        'Lx6_3end'     => { 'overThresh' => 0 },
                        'Lx4A_3end'    => { 'overThresh' => 0 },
                        'L1_Mur3_5end' => { 'overThresh' => 0 },
                        'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1PA17_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 33 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PBb_5end'     => { 'overThresh' => 33 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB4_3end'     => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 33 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 33 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 33 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1PB1_3end'     => { 'overThresh' => 33 },
                       'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1M1_orf2' => {
                     'L1M2a1_5end' => { 'overThresh' => 0 },
                     'L1M2'        => { 'overThresh' => 0 },
                     'L1M2b_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1MA4A_3end' => { 'overThresh' => 0 },
                     'L1M2_5end'   => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1MA2_3end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1MA4_3end'  => { 'overThresh' => 0 },
                     'L1MA3_3end'  => { 'overThresh' => 0 },
                     'L1MA5A_3end' => { 'overThresh' => 0 },
                     'L1M2a_5end'  => { 'overThresh' => 0 },
                     'L1M1_5end'   => { 'overThresh' => 0 },
                     'L1M1'        => { 'overThresh' => 0 },
                     'L1MA5_3end'  => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1MA10_3end' => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1M2_orf2'   => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1M2c_5end'  => { 'overThresh' => 0 },
                     'L1MA1_3end'  => { 'overThresh' => 0 }
    },
    'L1_Rat4_3end' => {
                        'L1_Rn_5end'   => { 'overThresh' => 33 },
                        'L1_Rat1_3end' => { 'overThresh' => 0 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'L1_Rn2_3end'  => { 'overThresh' => 33 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1_Rn_3end'   => { 'overThresh' => 33 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Rn_orf2'   => { 'overThresh' => 33 },
                        'L1_Rat2_3end' => { 'overThresh' => 0 },
                        'L1_Rat3_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 }
    },
    'L1P' => {
               'L1P4c_5end'     => { 'overThresh' => 0 },
               'L1PB2_3end'     => { 'overThresh' => 0 },
               'L1P1'           => { 'overThresh' => 0 },
               'L1PBa_5end'     => { 'overThresh' => 0 },
               'L1PA14_3end'    => { 'overThresh' => 0 },
               'L1P2'           => { 'overThresh' => 0 },
               'L1P2_5end'      => { 'overThresh' => 0 },
               'L1PA8_3end'     => { 'overThresh' => 0 },
               'L1PA13_3end'    => { 'overThresh' => 0 },
               'L1P1_orf2'      => { 'overThresh' => 0 },
               'L1PA3_3end'     => { 'overThresh' => 0 },
               'L1PA6_3end'     => { 'overThresh' => 0 },
               'L1Pt_5end'      => { 'overThresh' => 0 },
               'L1PREC2_orf2'   => { 'overThresh' => 0 },
               'L1P3_orf2'      => { 'overThresh' => 0 },
               'L1PA4_3end'     => { 'overThresh' => 0 },
               'L1PA13_5end'    => { 'overThresh' => 0 },
               'L1PA10_5end'    => { 'overThresh' => 0 },
               'L1PA15-16_5end' => { 'overThresh' => 0 },
               'L1PA5_3end'     => { 'overThresh' => 0 },
               'L1PBb_5end'     => { 'overThresh' => 0 },
               'L1P4a_5end'     => { 'overThresh' => 0 },
               'L1PREC2_3end'   => { 'overThresh' => 0 },
               'L1PA10_3end'    => { 'overThresh' => 0 },
               'L1Pt_3end'      => { 'overThresh' => 0 },
               'L1P4_orf2'      => { 'overThresh' => 0 },
               'L1PREC2_5end'   => { 'overThresh' => 0 },
               'L1PA7_3end'     => { 'overThresh' => 0 },
               'L1P3_5end'      => { 'overThresh' => 0 },
               'L1PA14_5end'    => { 'overThresh' => 0 },
               'L1P3'           => { 'overThresh' => 0 },
               'L1PA12_3end'    => { 'overThresh' => 0 },
               'L1PA12_5end'    => { 'overThresh' => 0 },
               'L1PA17_5end'    => { 'overThresh' => 0 },
               'L1PA16_3end'    => { 'overThresh' => 0 },
               'L1PA8A_3end'    => { 'overThresh' => 0 },
               'L1P3b_5end'     => { 'overThresh' => 0 },
               'L1PA11_3end'    => { 'overThresh' => 0 },
               'L1P5'           => { 'overThresh' => 0 },
               'L1PA2_3end'     => { 'overThresh' => 0 },
               'L1PA15_3end'    => { 'overThresh' => 0 },
               'L1PB4_3end'     => { 'overThresh' => 0 },
               'L1PB_orf2'      => { 'overThresh' => 0 },
               'L1P4'           => { 'overThresh' => 0 },
               'L1PBa1_5end'    => { 'overThresh' => 0 },
               'L1P4e_5end'     => { 'overThresh' => 0 },
               'L1P1_5end'      => { 'overThresh' => 0 },
               'L1P4b_5end'     => { 'overThresh' => 0 },
               'L1PB3_3end'     => { 'overThresh' => 0 },
               'L1P4d_5end'     => { 'overThresh' => 0 },
               'L1PB1_3end'     => { 'overThresh' => 0 },
               'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1ME2z_3end' => {
                       'L1MD'        => { 'overThresh' => 33 },
                       'L1M5'        => { 'overThresh' => 0 },
                       'L1MD2_5end'  => { 'overThresh' => 33 },
                       'L1MC2_3end'  => { 'overThresh' => 33 },
                       'L1MC5_3end'  => { 'overThresh' => 33 },
                       'L1M6_5end'   => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 0 },
                       'L1MEg_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 0 },
                       'L1MCa_5end'  => { 'overThresh' => 33 },
                       'L1M7_5end'   => { 'overThresh' => 0 },
                       'L1MB8_3end'  => { 'overThresh' => 33 },
                       'L1MC4_3endX' => { 'overThresh' => 33 },
                       'L1MD_orf2'   => { 'overThresh' => 33 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 33 },
                       'L1MC4_5end'  => { 'overThresh' => 33 },
                       'L1MC'        => { 'overThresh' => 33 },
                       'L1MC4_3end'  => { 'overThresh' => 33 },
                       'L1MA10_3end' => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 33 },
                       'L1MB5_3end'  => { 'overThresh' => 33 },
                       'L1MB7_3end'  => { 'overThresh' => 33 },
                       'L1MEa_5end'  => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 33 },
                       'L1MEg2_5end' => { 'overThresh' => 0 },
                       'L1MC_orf2'   => { 'overThresh' => 33 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1MDa_5end'  => { 'overThresh' => 33 },
                       'L1ME3A_3end' => { 'overThresh' => 0 },
                       'L1MEe_5end'  => { 'overThresh' => 0 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1MC3_3end'  => { 'overThresh' => 33 },
                       'L1MEg1_5end' => { 'overThresh' => 0 },
                       'L1ME4a_3end' => { 'overThresh' => 0 },
                       'L1MEc_5end'  => { 'overThresh' => 0 },
                       'L1MEd_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 33 },
                       'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1M3e_5end' => {
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'L1_Mdo4_orf2' => {
                        'L1_Mdo5_3end' => { 'overThresh' => 0 },
                        'L1_Mdo4_5end' => { 'overThresh' => 0 },
                        'L1_Mdo5_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo4_3end' => { 'overThresh' => 0 },
                        'L1_Mdo5_5end' => { 'overThresh' => 0 }
    },
    'L1P2' => {
                'L1PREC2_5end' => { 'overThresh' => 0 },
                'L1P3_5end'    => { 'overThresh' => 0 },
                'L1PA7_3end'   => { 'overThresh' => 0 },
                'L1P'          => { 'overThresh' => 0 },
                'L1P1'         => { 'overThresh' => 0 },
                'L1P3'         => { 'overThresh' => 0 },
                'L1PA8A_3end'  => { 'overThresh' => 0 },
                'L1P2_5end'    => { 'overThresh' => 0 },
                'L1P3b_5end'   => { 'overThresh' => 0 },
                'L1PA8_3end'   => { 'overThresh' => 0 },
                'L1P1_orf2'    => { 'overThresh' => 0 },
                'L1PA3_3end'   => { 'overThresh' => 0 },
                'L1PA6_3end'   => { 'overThresh' => 0 },
                'L1Pt_5end'    => { 'overThresh' => 0 },
                'L1PA2_3end'   => { 'overThresh' => 0 },
                'L1PREC2_orf2' => { 'overThresh' => 0 },
                'L1P3_orf2'    => { 'overThresh' => 0 },
                'L1PA4_3end'   => { 'overThresh' => 0 },
                'L1PA5_3end'   => { 'overThresh' => 0 },
                'L1P1_5end'    => { 'overThresh' => 0 }
    },
    'L1PA8_3end' => {
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA3_3end'     => { 'overThresh' => 33 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1PA2_3end'     => { 'overThresh' => 33 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA4_3end'     => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PA5_3end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1_Opos' => {
                   'L1_Opos_5end'    => { 'overThresh' => 0 },
                   'L1_Opos3_orf2'   => { 'overThresh' => 0 },
                   'HAL1_Opos1_5end' => { 'overThresh' => 0 },
                   'L1_Opos_orf2'    => { 'overThresh' => 0 }
    },
    'L1PA6_3end' => {
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1P1'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 33 },
                      'L1PA12_5end'    => { 'overThresh' => 33 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 33 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA3_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1PA2_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA4_3end'     => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 33 },
                      'L1PA5_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 33 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1ME3B_3end' => {
                       'L1MD'        => { 'overThresh' => 33 },
                       'L1M5'        => { 'overThresh' => 0 },
                       'L1MD2_5end'  => { 'overThresh' => 33 },
                       'L1ME2z_3end' => { 'overThresh' => 0 },
                       'L1MC2_3end'  => { 'overThresh' => 33 },
                       'L1MC5_3end'  => { 'overThresh' => 33 },
                       'L1M6_5end'   => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 0 },
                       'L1MEg_5end'  => { 'overThresh' => 0 },
                       'L1MCa_5end'  => { 'overThresh' => 33 },
                       'L1M7_5end'   => { 'overThresh' => 0 },
                       'L1MB8_3end'  => { 'overThresh' => 33 },
                       'L1MC4_3endX' => { 'overThresh' => 33 },
                       'L1MD_orf2'   => { 'overThresh' => 33 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 33 },
                       'L1MC4_5end'  => { 'overThresh' => 33 },
                       'L1MC'        => { 'overThresh' => 33 },
                       'L1MC4_3end'  => { 'overThresh' => 33 },
                       'L1MA10_3end' => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 33 },
                       'L1MB5_3end'  => { 'overThresh' => 33 },
                       'L1MB7_3end'  => { 'overThresh' => 33 },
                       'L1MEa_5end'  => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 33 },
                       'L1MEg2_5end' => { 'overThresh' => 0 },
                       'L1MC_orf2'   => { 'overThresh' => 33 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1MDa_5end'  => { 'overThresh' => 33 },
                       'L1ME3A_3end' => { 'overThresh' => 0 },
                       'L1MEe_5end'  => { 'overThresh' => 0 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1MC3_3end'  => { 'overThresh' => 33 },
                       'L1MEg1_5end' => { 'overThresh' => 0 },
                       'L1ME4a_3end' => { 'overThresh' => 0 },
                       'L1MEc_5end'  => { 'overThresh' => 0 },
                       'L1MEd_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 33 },
                       'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1PREC2_orf2' => {
                        'L1P4c_5end'     => { 'overThresh' => 0 },
                        'L1Pt_3end'      => { 'overThresh' => 0 },
                        'L1P4_orf2'      => { 'overThresh' => 0 },
                        'L1PREC2_5end'   => { 'overThresh' => 0 },
                        'L1P3_5end'      => { 'overThresh' => 0 },
                        'L1P'            => { 'overThresh' => 0 },
                        'L1P1'           => { 'overThresh' => 0 },
                        'L1PA14_5end'    => { 'overThresh' => 0 },
                        'L1P3'           => { 'overThresh' => 0 },
                        'L1PBa_5end'     => { 'overThresh' => 0 },
                        'L1PA12_5end'    => { 'overThresh' => 0 },
                        'L1PA17_5end'    => { 'overThresh' => 0 },
                        'L1P2'           => { 'overThresh' => 0 },
                        'L1P2_5end'      => { 'overThresh' => 0 },
                        'L1P3b_5end'     => { 'overThresh' => 0 },
                        'L1P1_orf2'      => { 'overThresh' => 0 },
                        'L1Pt_5end'      => { 'overThresh' => 0 },
                        'L1P5'           => { 'overThresh' => 0 },
                        'L1P4'           => { 'overThresh' => 0 },
                        'L1P3_orf2'      => { 'overThresh' => 0 },
                        'L1PBa1_5end'    => { 'overThresh' => 0 },
                        'L1PA13_5end'    => { 'overThresh' => 0 },
                        'L1PA10_5end'    => { 'overThresh' => 0 },
                        'L1PA15-16_5end' => { 'overThresh' => 0 },
                        'L1PBb_5end'     => { 'overThresh' => 0 },
                        'L1P4a_5end'     => { 'overThresh' => 0 },
                        'L1P4e_5end'     => { 'overThresh' => 0 },
                        'L1PREC2_3end'   => { 'overThresh' => 0 },
                        'L1P4b_5end'     => { 'overThresh' => 0 },
                        'L1P1_5end'      => { 'overThresh' => 0 },
                        'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'Lx9_3end' => {
                    'L1_Rod_orf2' => { 'overThresh' => 0 },
                    'L1_Rod_5end' => { 'overThresh' => 0 }
    },
    'HAL1-3A_ME' => { 'HAL1' => { 'overThresh' => 0 } },
    'L1P3_orf2'  => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1P2'           => { 'overThresh' => 0 },
                     'L1PA8_3end'     => { 'overThresh' => 0 },
                     'L1PA13_3end'    => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1PA6_3end'     => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1PA10_3end'    => { 'overThresh' => 0 },
                     'L1P4_orf2'      => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1PA7_3end'     => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1PA12_3end'    => { 'overThresh' => 0 },
                     'L1P3'           => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1PA8A_3end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1PA11_3end'    => { 'overThresh' => 0 },
                     'L1P4'           => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1MA8_3end' => {
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'L1M1_5end' => {
                     'L1M2a1_5end' => { 'overThresh' => 0 },
                     'L1M1_orf2'   => { 'overThresh' => 0 },
                     'L1M2'        => { 'overThresh' => 0 },
                     'L1M2b_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1MA4A_3end' => { 'overThresh' => 0 },
                     'L1M2_5end'   => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1MA2_3end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1MA4_3end'  => { 'overThresh' => 0 },
                     'L1MA3_3end'  => { 'overThresh' => 0 },
                     'L1MA5A_3end' => { 'overThresh' => 0 },
                     'L1M2a_5end'  => { 'overThresh' => 0 },
                     'L1M1'        => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1MA5_3end'  => { 'overThresh' => 0 },
                     'L1M3_orf2'   => { 'overThresh' => 0 },
                     'L1MA10_3end' => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1M2_orf2'   => { 'overThresh' => 0 },
                     'L1M2c_5end'  => { 'overThresh' => 0 },
                     'L1MA1_3end'  => { 'overThresh' => 0 }
    },
    'L1_Carn5_3end' => { 'L1_Carn5_5end' => { 'overThresh' => 0 } },
    'L1PA5_3end'    => {
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1P1'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 33 },
                      'L1PA12_5end'    => { 'overThresh' => 33 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 33 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA3_3end'     => { 'overThresh' => 0 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1PA2_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PA4_3end'     => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 33 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 33 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1M4' => {
                'L1M5'        => { 'overThresh' => 0 },
                'L1M3a_5end'  => { 'overThresh' => 0 },
                'L1MB4_5end'  => { 'overThresh' => 0 },
                'L1M3e_5end'  => { 'overThresh' => 0 },
                'L1MC5_3end'  => { 'overThresh' => 0 },
                'L1M3b_5end'  => { 'overThresh' => 0 },
                'L1MC3_3end'  => { 'overThresh' => 0 },
                'L1M3d_5end'  => { 'overThresh' => 0 },
                'L1M4c_5end'  => { 'overThresh' => 0 },
                'L1MB8_3end'  => { 'overThresh' => 0 },
                'L1MC4_3endX' => { 'overThresh' => 0 },
                'L1MB4_3end'  => { 'overThresh' => 0 },
                'L1MC4a_3end' => { 'overThresh' => 0 },
                'L1M4_5end'   => { 'overThresh' => 0 },
                'L1M4b_5end'  => { 'overThresh' => 0 },
                'L1M5_orf2'   => { 'overThresh' => 0 },
                'L1M4_orf2'   => { 'overThresh' => 0 },
                'L1M3f_5end'  => { 'overThresh' => 0 },
                'L1M3_orf2'   => { 'overThresh' => 0 },
                'L1M3c_5end'  => { 'overThresh' => 0 },
                'L1ME1_3end'  => { 'overThresh' => 0 },
                'L1MC4_3end'  => { 'overThresh' => 0 },
                'L1MC4_5end'  => { 'overThresh' => 0 },
                'L1MD3_3end'  => { 'overThresh' => 0 },
                'L1M3de_5end' => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 },
                'L1M3'        => { 'overThresh' => 0 },
                'L1MB5_3end'  => { 'overThresh' => 0 },
                'L1MB7_3end'  => { 'overThresh' => 0 }
    },
    'L1_Mm_orf2' => {
                      'Lx2_3end'     => { 'overThresh' => 0 },
                      'Lx2B_3end'    => { 'overThresh' => 0 },
                      'L1_Mus3_3end' => { 'overThresh' => 0 },
                      'L1Md_Gf_5end' => { 'overThresh' => 0 },
                      'L1_Mus1_3end' => { 'overThresh' => 0 },
                      'L1_Mus2_3end' => { 'overThresh' => 0 },
                      'Lx2A1_3end'   => { 'overThresh' => 0 },
                      'L1Md_F3_3end' => { 'overThresh' => 0 },
                      'L1Md_T_3end'  => { 'overThresh' => 0 },
                      'Lx_3end'      => { 'overThresh' => 0 },
                      'Lx2A_3end'    => { 'overThresh' => 0 },
                      'L1Md_A_5end'  => { 'overThresh' => 0 },
                      'L1Md_F_5end'  => { 'overThresh' => 0 },
                      'L1Md_A_3end'  => { 'overThresh' => 0 },
                      'L1_Mus4_3end' => { 'overThresh' => 0 },
                      'L1Md_F2_3end' => { 'overThresh' => 0 }
    },
    'HAL1N1_MD_5end' => { 'HAL1' => { 'overThresh' => 0 } },
    'L1M2b_5end'     => {
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'L1_Carn2_orf2' => {
                         'L1_Carn3_3end'  => { 'overThresh' => 0 },
                         'L1_Carn3_5end'  => { 'overThresh' => 0 },
                         'L1_Canis5_5end' => { 'overThresh' => 0 },
                         'L1_Carn2_3end'  => { 'overThresh' => 0 },
                         'L1_Canis4_5end' => { 'overThresh' => 0 },
                         'L1_Carn2_5end'  => { 'overThresh' => 0 },
                         'L1_Carn1_5end'  => { 'overThresh' => 0 },
                         'L1_Canis4_3end' => { 'overThresh' => 0 },
                         'L1_Canis4_orf2' => { 'overThresh' => 0 }
    },
    'L1PA16_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 33 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PBb_5end'     => { 'overThresh' => 33 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB4_3end'     => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 33 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 33 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 33 },
                       'L1PB1_3end'     => { 'overThresh' => 33 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1ME3A_3end' => {
                       'L1MD'        => { 'overThresh' => 33 },
                       'L1M5'        => { 'overThresh' => 0 },
                       'L1MD2_5end'  => { 'overThresh' => 33 },
                       'L1ME2z_3end' => { 'overThresh' => 0 },
                       'L1MC2_3end'  => { 'overThresh' => 33 },
                       'L1MC5_3end'  => { 'overThresh' => 33 },
                       'L1M6_5end'   => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 0 },
                       'L1MEg_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 0 },
                       'L1MCa_5end'  => { 'overThresh' => 33 },
                       'L1M7_5end'   => { 'overThresh' => 0 },
                       'L1MB8_3end'  => { 'overThresh' => 33 },
                       'L1MC4_3endX' => { 'overThresh' => 33 },
                       'L1MD_orf2'   => { 'overThresh' => 33 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 33 },
                       'L1MC4_3end'  => { 'overThresh' => 33 },
                       'L1MC4_5end'  => { 'overThresh' => 33 },
                       'L1MC'        => { 'overThresh' => 33 },
                       'L1MA10_3end' => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 33 },
                       'L1MB5_3end'  => { 'overThresh' => 33 },
                       'L1MB7_3end'  => { 'overThresh' => 33 },
                       'L1MEa_5end'  => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 33 },
                       'L1MEg2_5end' => { 'overThresh' => 0 },
                       'L1MC_orf2'   => { 'overThresh' => 33 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1MDa_5end'  => { 'overThresh' => 33 },
                       'L1MEe_5end'  => { 'overThresh' => 0 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1MC3_3end'  => { 'overThresh' => 33 },
                       'L1MEg1_5end' => { 'overThresh' => 0 },
                       'L1ME4a_3end' => { 'overThresh' => 0 },
                       'L1MEc_5end'  => { 'overThresh' => 0 },
                       'L1MEd_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 33 },
                       'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1ME4a_3end' => {
                       'L1MD'        => { 'overThresh' => 33 },
                       'L1M5'        => { 'overThresh' => 0 },
                       'L1MD2_5end'  => { 'overThresh' => 33 },
                       'L1ME2z_3end' => { 'overThresh' => 0 },
                       'L1MC2_3end'  => { 'overThresh' => 33 },
                       'L1MC5_3end'  => { 'overThresh' => 33 },
                       'L1M6_5end'   => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 0 },
                       'L1MEg_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 0 },
                       'L1MCa_5end'  => { 'overThresh' => 33 },
                       'L1M7_5end'   => { 'overThresh' => 0 },
                       'L1MC4_3endX' => { 'overThresh' => 33 },
                       'L1MD_orf2'   => { 'overThresh' => 33 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 33 },
                       'L1MC'        => { 'overThresh' => 33 },
                       'L1MC4_3end'  => { 'overThresh' => 33 },
                       'L1MC4_5end'  => { 'overThresh' => 33 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 33 },
                       'L1MEa_5end'  => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 33 },
                       'L1MEg2_5end' => { 'overThresh' => 0 },
                       'L1MC_orf2'   => { 'overThresh' => 33 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1MDa_5end'  => { 'overThresh' => 33 },
                       'L1ME3A_3end' => { 'overThresh' => 0 },
                       'L1MEe_5end'  => { 'overThresh' => 0 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MC3_3end'  => { 'overThresh' => 33 },
                       'L1MEg1_5end' => { 'overThresh' => 0 },
                       'L1MEc_5end'  => { 'overThresh' => 0 },
                       'L1MEd_5end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 33 },
                       'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1_Rod_orf2' => {
                       'Lx8_3end' => { 'overThresh' => 0 },
                       'Lx9_3end' => { 'overThresh' => 0 }
    },
    'L1P4' => {
                'L1P4_orf2'      => { 'overThresh' => 0 },
                'L1P4c_5end'     => { 'overThresh' => 0 },
                'L1PB2_3end'     => { 'overThresh' => 0 },
                'L1PREC2_5end'   => { 'overThresh' => 0 },
                'L1P3_5end'      => { 'overThresh' => 0 },
                'L1P'            => { 'overThresh' => 0 },
                'L1PA14_5end'    => { 'overThresh' => 0 },
                'L1P3'           => { 'overThresh' => 0 },
                'L1PA12_3end'    => { 'overThresh' => 0 },
                'L1PA12_5end'    => { 'overThresh' => 0 },
                'L1PA17_5end'    => { 'overThresh' => 0 },
                'L1PA14_3end'    => { 'overThresh' => 0 },
                'L1PA16_3end'    => { 'overThresh' => 0 },
                'L1P3b_5end'     => { 'overThresh' => 0 },
                'L1PA11_3end'    => { 'overThresh' => 0 },
                'L1PA13_3end'    => { 'overThresh' => 0 },
                'L1P5'           => { 'overThresh' => 0 },
                'L1Pt_5end'      => { 'overThresh' => 0 },
                'L1PA15_3end'    => { 'overThresh' => 0 },
                'L1PREC2_orf2'   => { 'overThresh' => 0 },
                'L1P3_orf2'      => { 'overThresh' => 0 },
                'L1PA13_5end'    => { 'overThresh' => 0 },
                'L1PA10_5end'    => { 'overThresh' => 0 },
                'L1PA15-16_5end' => { 'overThresh' => 0 },
                'L1P4a_5end'     => { 'overThresh' => 0 },
                'L1P4e_5end'     => { 'overThresh' => 0 },
                'L1P4b_5end'     => { 'overThresh' => 0 },
                'L1PB3_3end'     => { 'overThresh' => 0 },
                'L1PA10_3end'    => { 'overThresh' => 0 },
                'L1P4d_5end'     => { 'overThresh' => 0 },
                'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1PBa1_5end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 33 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1P1_orf2'      => { 'overThresh' => 0 },
                       'L1Pt_5end'      => { 'overThresh' => 0 },
                       'L1PREC2_orf2'   => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PBb_5end'     => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_5end'   => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 33 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1P5'           => { 'overThresh' => 0 },
                       'L1PB4_3end'     => { 'overThresh' => 0 },
                       'L1PA15_3end'    => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P1_5end'      => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 0 },
                       'L1PB1_3end'     => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1P4e_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1_Canis1_orf2' => {
                          'L1_Canis2_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_3end' => { 'overThresh' => 0 },
                          'L1_Canis2_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_3end' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1P4c_5end' => {
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'Lx7_3end' => {
                    'L1_Mur3_5end' => { 'overThresh' => 0 },
                    'L1_Mur3_orf2' => { 'overThresh' => 0 }
    },
    'L1_Carn7_orf2' => {
                         'L1_Carn7_5end' => { 'overThresh' => 0 },
                         'L1_Carn7_3end' => { 'overThresh' => 0 }
    },
    'L1PA14_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 33 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PBb_5end'     => { 'overThresh' => 33 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB4_3end'     => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 33 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 33 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 33 },
                       'L1PB1_3end'     => { 'overThresh' => 33 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'ATLINE1_10A' => {
                       'ATLINE1_1'  => { 'overThresh' => 0 },
                       'ATLINE1_10' => { 'overThresh' => 0 }
    },
    'L1_Mus1_3end' => {
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1Md_Gf_5end' => { 'overThresh' => 33 },
                        'L1_Mus3_3end' => { 'overThresh' => 0 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Mus2_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 },
                        'L1Md_F3_3end' => { 'overThresh' => 33 },
                        'L1Md_T_3end'  => { 'overThresh' => 33 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'L1Md_A_5end'  => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 33 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1Md_A_3end'  => { 'overThresh' => 33 },
                        'L1_Mus4_3end' => { 'overThresh' => 0 },
                        'L1Md_F2_3end' => { 'overThresh' => 33 }
    },
    'L1_Canis2_orf2' => {
                          'L1_Canis2_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis1_3end' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'L1MA2_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 0 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 33 }
    },
    'L1PA4_3end' => {
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1P1'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 33 },
                      'L1PA12_5end'    => { 'overThresh' => 33 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 33 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA3_3end'     => { 'overThresh' => 0 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1PA2_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA5_3end'     => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 33 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 33 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1M4_5end' => {
                     'L1M5'        => { 'overThresh' => 0 },
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1MC5_3end'  => { 'overThresh' => 0 },
                     'L1M6_5end'   => { 'overThresh' => 0 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1M7_5end'   => { 'overThresh' => 0 },
                     'L1MB8_3end'  => { 'overThresh' => 0 },
                     'L1MC4_3endX' => { 'overThresh' => 0 },
                     'L1MB4_3end'  => { 'overThresh' => 0 },
                     'L1MD_orf2'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1M5_orf2'   => { 'overThresh' => 0 },
                     'L1M4'        => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1M3_orf2'   => { 'overThresh' => 0 },
                     'L1MC4_3end'  => { 'overThresh' => 0 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1M2_orf2'   => { 'overThresh' => 0 },
                     'L1MB7_3end'  => { 'overThresh' => 0 },
                     'L1MB5_3end'  => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 },
                     'L1M2a1_5end' => { 'overThresh' => 0 },
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1MC_orf2'   => { 'overThresh' => 0 },
                     'L1M2b_5end'  => { 'overThresh' => 0 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1MB4_5end'  => { 'overThresh' => 0 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1M2_5end'   => { 'overThresh' => 0 },
                     'L1MC3_3end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1MEb_5end'  => { 'overThresh' => 0 },
                     'L1M2a_5end'  => { 'overThresh' => 0 },
                     'L1MC4a_3end' => { 'overThresh' => 0 },
                     'L1ME1_3end'  => { 'overThresh' => 0 },
                     'L1M4_orf2'   => { 'overThresh' => 0 },
                     'L1MD3_3end'  => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1M3'        => { 'overThresh' => 0 },
                     'L1M2c_5end'  => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1M4b_5end' => {
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1MB7_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1MA10_3end' => {
                       'L1M1_orf2'   => { 'overThresh' => 0 },
                       'L1ME2z_3end' => { 'overThresh' => 0 },
                       'L1M3e_5end'  => { 'overThresh' => 0 },
                       'L1M3b_5end'  => { 'overThresh' => 0 },
                       'L1MA2_3end'  => { 'overThresh' => 33 },
                       'L1M3d_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 0 },
                       'L1MB8_3end'  => { 'overThresh' => 33 },
                       'L1MA3_3end'  => { 'overThresh' => 33 },
                       'L1MA5A_3end' => { 'overThresh' => 33 },
                       'L1M1_5end'   => { 'overThresh' => 0 },
                       'L1MA8_3end'  => { 'overThresh' => 0 },
                       'L1MB4_3end'  => { 'overThresh' => 33 },
                       'L1MB1_3end'  => { 'overThresh' => 0 },
                       'L1MA5_3end'  => { 'overThresh' => 33 },
                       'L1M3_orf2'   => { 'overThresh' => 0 },
                       'L1M3c_5end'  => { 'overThresh' => 0 },
                       'L1M3f_5end'  => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MA7_3end'  => { 'overThresh' => 33 },
                       'L1MB5_3end'  => { 'overThresh' => 33 },
                       'L1MB7_3end'  => { 'overThresh' => 33 },
                       'L1MA6_3end'  => { 'overThresh' => 33 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1M3a_5end'  => { 'overThresh' => 0 },
                       'L1MB2_3end'  => { 'overThresh' => 0 },
                       'L1MB4_5end'  => { 'overThresh' => 33 },
                       'L1ME3A_3end' => { 'overThresh' => 0 },
                       'L1MA4A_3end' => { 'overThresh' => 33 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MA4_3end'  => { 'overThresh' => 33 },
                       'L1M1'        => { 'overThresh' => 0 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1M3de_5end' => { 'overThresh' => 0 },
                       'L1M3'        => { 'overThresh' => 0 },
                       'L1MB3_3end'  => { 'overThresh' => 0 },
                       'L1MA1_3end'  => { 'overThresh' => 33 }
    },
    'L1MA7_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 }
    },
    'RNHAL1'       => { 'RNHAL1_5end' => { 'overThresh' => 0 } },
    'L1_Opos_5end' => { 'L1_Opos'     => { 'overThresh' => 0 } },
    'L1_RS1_orf2'  => {
                       'L1_RS2_3end' => { 'overThresh' => 0 },
                       'L1_RS1_3end' => { 'overThresh' => 0 },
                       'L1_RS1_5end' => { 'overThresh' => 0 }
    },
    'L1_Mdo6_3end' => {
                        'L1_Mdo5_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo5_5end' => { 'overThresh' => 0 }
    },
    'L1_Mdo1_orf2' => {
                        'L1_Mdo1_3end' => { 'overThresh' => 0 },
                        'L1_Mdo2_5end' => { 'overThresh' => 0 },
                        'L1_Mdo2_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_3end' => { 'overThresh' => 0 },
                        'L1_Mdo1_5end' => { 'overThresh' => 0 }
    },
    'L1_Mdo5_5end' => {
                        'L1_Mdo4_5end' => { 'overThresh' => 0 },
                        'L1_Mdo5_3end' => { 'overThresh' => 0 },
                        'L1_Mdo4_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo5_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo4_3end' => { 'overThresh' => 0 },
                        'L1_Mdo6_3end' => { 'overThresh' => 0 }
    },
    'L1MEb_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'Lx2A_3end' => {
                     'L1_Rat1_3end' => { 'overThresh' => 33 },
                     'L1_Rat4_3end' => { 'overThresh' => 33 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mus3_3end' => { 'overThresh' => 33 },
                     'L1_Mus1_3end' => { 'overThresh' => 33 },
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Rat2_3end' => { 'overThresh' => 33 },
                     'L1_Rn_orf2'   => { 'overThresh' => 0 },
                     'L1_Mus2_3end' => { 'overThresh' => 33 },
                     'L1_Mm_orf2'   => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Rat3_3end' => { 'overThresh' => 33 },
                     'L1_Mus4_3end' => { 'overThresh' => 33 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1M1' => {
                'L1M2a1_5end' => { 'overThresh' => 0 },
                'L1M1_orf2'   => { 'overThresh' => 0 },
                'L1M2'        => { 'overThresh' => 0 },
                'L1M2b_5end'  => { 'overThresh' => 0 },
                'L1MA4A_3end' => { 'overThresh' => 0 },
                'L1M2_5end'   => { 'overThresh' => 0 },
                'L1MA2_3end'  => { 'overThresh' => 0 },
                'L1MA4_3end'  => { 'overThresh' => 0 },
                'L1MA3_3end'  => { 'overThresh' => 0 },
                'L1MA5A_3end' => { 'overThresh' => 0 },
                'L1M1_5end'   => { 'overThresh' => 0 },
                'L1M2a_5end'  => { 'overThresh' => 0 },
                'L1MA5_3end'  => { 'overThresh' => 0 },
                'L1MA10_3end' => { 'overThresh' => 0 },
                'L1M2_orf2'   => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 },
                'L1M2c_5end'  => { 'overThresh' => 0 },
                'L1MA1_3end'  => { 'overThresh' => 0 }
    },
    'L1_Rn_3end' => {
                      'L1_Rn_5end'   => { 'overThresh' => 0 },
                      'L1_Rat1_3end' => { 'overThresh' => 33 },
                      'L1_Rat2_3end' => { 'overThresh' => 33 },
                      'L1_Rn2_3end'  => { 'overThresh' => 0 },
                      'L1_Rn_orf2'   => { 'overThresh' => 0 },
                      'L1_Rat4_3end' => { 'overThresh' => 33 },
                      'L1_Rat3_3end' => { 'overThresh' => 33 }
    },
    'L1M3de_5end' => {
                       'L1M1_orf2'   => { 'overThresh' => 0 },
                       'L1M2'        => { 'overThresh' => 0 },
                       'L1M3e_5end'  => { 'overThresh' => 0 },
                       'L1M3b_5end'  => { 'overThresh' => 0 },
                       'L1M3d_5end'  => { 'overThresh' => 0 },
                       'L1MA8_3end'  => { 'overThresh' => 0 },
                       'L1M1_5end'   => { 'overThresh' => 0 },
                       'L1MB4_3end'  => { 'overThresh' => 0 },
                       'L1M4_5end'   => { 'overThresh' => 0 },
                       'L1M4b_5end'  => { 'overThresh' => 0 },
                       'L1M4'        => { 'overThresh' => 0 },
                       'L1M3_orf2'   => { 'overThresh' => 0 },
                       'L1MB1_3end'  => { 'overThresh' => 0 },
                       'L1M3c_5end'  => { 'overThresh' => 0 },
                       'L1M3f_5end'  => { 'overThresh' => 0 },
                       'L1MA10_3end' => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1M2_orf2'   => { 'overThresh' => 0 },
                       'L1MA9_3end'  => { 'overThresh' => 0 },
                       'L1MB5_3end'  => { 'overThresh' => 0 },
                       'L1M2a1_5end' => { 'overThresh' => 0 },
                       'L1M2b_5end'  => { 'overThresh' => 0 },
                       'L1M3a_5end'  => { 'overThresh' => 0 },
                       'L1MB2_3end'  => { 'overThresh' => 0 },
                       'L1MB4_5end'  => { 'overThresh' => 0 },
                       'L1M2_5end'   => { 'overThresh' => 0 },
                       'L1M4c_5end'  => { 'overThresh' => 0 },
                       'L1M2a_5end'  => { 'overThresh' => 0 },
                       'L1M4_orf2'   => { 'overThresh' => 0 },
                       'L1M3'        => { 'overThresh' => 0 },
                       'L1M2c_5end'  => { 'overThresh' => 0 },
                       'L1MB3_3end'  => { 'overThresh' => 0 }
    },
    'L1PB1_3end' => {
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1PB4_3end'     => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1MA1_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 0 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 }
    },
    'L1MD2_5end' => {
                      'L1MD'        => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1P2_5end' => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1P1'           => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1P2'           => { 'overThresh' => 0 },
                     'L1PA8_3end'     => { 'overThresh' => 0 },
                     'L1PA3_3end'     => { 'overThresh' => 0 },
                     'L1PA6_3end'     => { 'overThresh' => 0 },
                     'L1P1_orf2'      => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1P3_orf2'      => { 'overThresh' => 0 },
                     'L1PA4_3end'     => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PA5_3end'     => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1P4_orf2'      => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1PA7_3end'     => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1P3'           => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1PA8A_3end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1PA2_3end'     => { 'overThresh' => 0 },
                     'L1PB_orf2'      => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1P1_orf2' => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1P1'           => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1P2'           => { 'overThresh' => 0 },
                     'L1PA6_3end'     => { 'overThresh' => 0 },
                     'L1PA3_3end'     => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1PA4_3end'     => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PA5_3end'     => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1PREC2_3end'   => { 'overThresh' => 0 },
                     'L1HS_3end'      => { 'overThresh' => 0 },
                     'L1Pt_3end'      => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1HS_5end'      => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1PA7_3end'     => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1PA2_3end'     => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1Pt_5end' => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1Pt_3end'      => { 'overThresh' => 0 },
                     'L1P4_orf2'      => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1P1'           => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1P3'           => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1P2'           => { 'overThresh' => 0 },
                     'L1P5'           => { 'overThresh' => 0 },
                     'L1P1_orf2'      => { 'overThresh' => 0 },
                     'L1PREC2_orf2'   => { 'overThresh' => 0 },
                     'L1PB_orf2'      => { 'overThresh' => 0 },
                     'L1P4'           => { 'overThresh' => 0 },
                     'L1P3_orf2'      => { 'overThresh' => 0 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1PREC2_3end'   => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 }
    },
    'L1_Opos1_3end' => { 'HAL1_Opos1_5end' => { 'overThresh' => 0 } },
    'L1M7_5end'     => {
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1M5'        => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1ME3_3end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1ME2z_3end' => { 'overThresh' => 0 },
                     'L1M6_5end'   => { 'overThresh' => 0 },
                     'L1ME3A_3end' => { 'overThresh' => 0 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1ME2_3end'  => { 'overThresh' => 0 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1ME4a_3end' => { 'overThresh' => 0 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1ME3B_3end' => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1ME5_3end'  => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1ME1_3end'  => { 'overThresh' => 0 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 }
    },
    'L1MB8_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 0 },
                      'L1MB7_3end'  => { 'overThresh' => 0 }
    },
    'L1_Carn2_3end' => {
                         'L1_Carn2_5end'  => { 'overThresh' => 0 },
                         'L1_Carn1_5end'  => { 'overThresh' => 0 },
                         'L1_Carn3_5end'  => { 'overThresh' => 0 },
                         'L1_Canis5_5end' => { 'overThresh' => 0 },
                         'L1_Canis4_orf2' => { 'overThresh' => 0 },
                         'L1_Carn2_orf2'  => { 'overThresh' => 0 },
                         'L1_Canis4_5end' => { 'overThresh' => 0 }
    },
    'L1M5_orf2' => {
                     'L1M5'        => { 'overThresh' => 0 },
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1ME2z_3end' => { 'overThresh' => 0 },
                     'L1MC5_3end'  => { 'overThresh' => 0 },
                     'L1M6_5end'   => { 'overThresh' => 0 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1ME3B_3end' => { 'overThresh' => 0 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1MC4_3endX' => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1M4'        => { 'overThresh' => 0 },
                     'L1MC4_3end'  => { 'overThresh' => 0 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 },
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1ME3_3end'  => { 'overThresh' => 0 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1ME3A_3end' => { 'overThresh' => 0 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1ME2_3end'  => { 'overThresh' => 0 },
                     'L1MC3_3end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1ME4a_3end' => { 'overThresh' => 0 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1MEb_5end'  => { 'overThresh' => 0 },
                     'L1MC4a_3end' => { 'overThresh' => 0 },
                     'L1M4_orf2'   => { 'overThresh' => 0 },
                     'L1ME1_3end'  => { 'overThresh' => 0 },
                     'L1MD3_3end'  => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'Lx4B_3end' => {
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1MB1_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 }
    },
    'L1MC4_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1_Mdo2_5end' => {
                        'L1_Mdo1_3end' => { 'overThresh' => 0 },
                        'L1_Mdo1_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo1_5end' => { 'overThresh' => 0 },
                        'L1_Mdo2_3end' => { 'overThresh' => 0 }
    },
    'L1_Rat3_3end' => {
                        'L1_Rn_5end'   => { 'overThresh' => 33 },
                        'L1_Rat1_3end' => { 'overThresh' => 0 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'L1_Rn2_3end'  => { 'overThresh' => 33 },
                        'L1_Rat4_3end' => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1_Rn_3end'   => { 'overThresh' => 33 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Rn_orf2'   => { 'overThresh' => 33 },
                        'L1_Rat2_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 }
    },
    'L1HS_3end' => {
                     'L1P1_5end' => { 'overThresh' => 0 },
                     'L1P1'      => { 'overThresh' => 0 },
                     'L1P1_orf2' => { 'overThresh' => 0 }
    },
    'MusHAL1'      => { 'MusHAL1_5end' => { 'overThresh' => 0 } },
    'L1_Mur1_orf2' => {
                        'Lx_3end'      => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 0 },
                        'Lx3C_3end'    => { 'overThresh' => 0 },
                        'L1_Mur2_5end' => { 'overThresh' => 0 },
                        'Lx3B_3end'    => { 'overThresh' => 0 },
                        'Lx2_3end'     => { 'overThresh' => 0 },
                        'Lx4B_3end'    => { 'overThresh' => 0 },
                        'Lx2B_3end'    => { 'overThresh' => 0 },
                        'L1_Mur1_5end' => { 'overThresh' => 0 },
                        'Lx3A_3end'    => { 'overThresh' => 0 },
                        'L1_Mur2_orf2' => { 'overThresh' => 0 },
                        'Lx4A_3end'    => { 'overThresh' => 0 },
                        'Lx3_Mus_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 0 }
    },
    'HAL1' => {
                'HAL1-3A_ME'      => { 'overThresh' => 0 },
                'HAL1_Opos1_5end' => { 'overThresh' => 0 },
                'HAL1b'           => { 'overThresh' => 0 },
                'HAL1N1_MD_5end'  => { 'overThresh' => 0 },
                'HAL1-2a_MD'      => { 'overThresh' => 0 }
    },
    'L1P3' => {
                'L1P4_orf2'    => { 'overThresh' => 0 },
                'L1P4c_5end'   => { 'overThresh' => 0 },
                'L1PREC2_5end' => { 'overThresh' => 0 },
                'L1P3_5end'    => { 'overThresh' => 0 },
                'L1PA7_3end'   => { 'overThresh' => 0 },
                'L1P'          => { 'overThresh' => 0 },
                'L1PA12_3end'  => { 'overThresh' => 0 },
                'L1PA12_5end'  => { 'overThresh' => 0 },
                'L1PA8A_3end'  => { 'overThresh' => 0 },
                'L1P2'         => { 'overThresh' => 0 },
                'L1P3b_5end'   => { 'overThresh' => 0 },
                'L1P2_5end'    => { 'overThresh' => 0 },
                'L1PA11_3end'  => { 'overThresh' => 0 },
                'L1PA8_3end'   => { 'overThresh' => 0 },
                'L1PA13_3end'  => { 'overThresh' => 0 },
                'L1PA6_3end'   => { 'overThresh' => 0 },
                'L1Pt_5end'    => { 'overThresh' => 0 },
                'L1PREC2_orf2' => { 'overThresh' => 0 },
                'L1P4'         => { 'overThresh' => 0 },
                'L1P3_orf2'    => { 'overThresh' => 0 },
                'L1PA13_5end'  => { 'overThresh' => 0 },
                'L1PA10_5end'  => { 'overThresh' => 0 },
                'L1P4a_5end'   => { 'overThresh' => 0 },
                'L1P4e_5end'   => { 'overThresh' => 0 },
                'L1P4b_5end'   => { 'overThresh' => 0 },
                'L1PA10_3end'  => { 'overThresh' => 0 },
                'L1P4d_5end'   => { 'overThresh' => 0 }
    },
    'L1_RS1_5end' => {
                       'L1_RS2_3end' => { 'overThresh' => 0 },
                       'L1_RS1_3end' => { 'overThresh' => 0 },
                       'L1_RS1_orf2' => { 'overThresh' => 0 }
    },
    'L1MEg1_5end' => {
                       'L1MD2_5end'  => { 'overThresh' => 0 },
                       'L1ME2z_3end' => { 'overThresh' => 0 },
                       'L1MC5_3end'  => { 'overThresh' => 33 },
                       'L1MC2_3end'  => { 'overThresh' => 33 },
                       'L1M6_5end'   => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 0 },
                       'L1MEg_5end'  => { 'overThresh' => 0 },
                       'L1MCa_5end'  => { 'overThresh' => 0 },
                       'L1ME3B_3end' => { 'overThresh' => 0 },
                       'L1M7_5end'   => { 'overThresh' => 0 },
                       'L1MD_orf2'   => { 'overThresh' => 0 },
                       'L1M4_5end'   => { 'overThresh' => 0 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1M4b_5end'  => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 33 },
                       'L1MC4_5end'  => { 'overThresh' => 0 },
                       'L1MC4_3end'  => { 'overThresh' => 33 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 0 },
                       'L1MEa_5end'  => { 'overThresh' => 0 },
                       'L1MCb_5end'  => { 'overThresh' => 0 },
                       'L1MC_orf2'   => { 'overThresh' => 0 },
                       'L1ME3_3end'  => { 'overThresh' => 0 },
                       'L1MEg2_5end' => { 'overThresh' => 0 },
                       'L1MDa_5end'  => { 'overThresh' => 0 },
                       'L1ME3A_3end' => { 'overThresh' => 0 },
                       'L1MEe_5end'  => { 'overThresh' => 0 },
                       'L1ME2_3end'  => { 'overThresh' => 0 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1MC3_3end'  => { 'overThresh' => 33 },
                       'L1ME4a_3end' => { 'overThresh' => 0 },
                       'L1MEc_5end'  => { 'overThresh' => 0 },
                       'L1MEd_5end'  => { 'overThresh' => 0 },
                       'L1M4c_5end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 0 },
                       'L1ME5_3end'  => { 'overThresh' => 0 },
                       'L1MC4a_3end' => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 0 },
                       'L1M4_orf2'   => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 33 },
                       'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1MEc_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Mdo5_orf2' => {
                        'L1_Mdo4_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo5_3end' => { 'overThresh' => 0 },
                        'L1_Mdo4_5end' => { 'overThresh' => 0 },
                        'L1_Mdo4_3end' => { 'overThresh' => 0 },
                        'L1_Mdo6_3end' => { 'overThresh' => 0 },
                        'L1_Mdo5_5end' => { 'overThresh' => 0 }
    },
    'L1MA4_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 0 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA5_3end'  => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1PB3_3end'  => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 0 },
                      'L1MB5_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 }
    },
    'L1PB_orf2' => {
                     'L1P4c_5end'     => { 'overThresh' => 0 },
                     'L1PB2_3end'     => { 'overThresh' => 0 },
                     'L1PREC2_5end'   => { 'overThresh' => 0 },
                     'L1P3_5end'      => { 'overThresh' => 0 },
                     'L1P'            => { 'overThresh' => 0 },
                     'L1PA14_5end'    => { 'overThresh' => 0 },
                     'L1PBa_5end'     => { 'overThresh' => 0 },
                     'L1PA12_5end'    => { 'overThresh' => 0 },
                     'L1PA17_5end'    => { 'overThresh' => 0 },
                     'L1PA16_3end'    => { 'overThresh' => 33 },
                     'L1PA14_3end'    => { 'overThresh' => 33 },
                     'L1P2_5end'      => { 'overThresh' => 0 },
                     'L1P3b_5end'     => { 'overThresh' => 0 },
                     'L1Pt_5end'      => { 'overThresh' => 0 },
                     'L1P5'           => { 'overThresh' => 0 },
                     'L1PB4_3end'     => { 'overThresh' => 0 },
                     'L1PA15_3end'    => { 'overThresh' => 33 },
                     'L1PBa1_5end'    => { 'overThresh' => 0 },
                     'L1PA13_5end'    => { 'overThresh' => 0 },
                     'L1PA15-16_5end' => { 'overThresh' => 0 },
                     'L1PA10_5end'    => { 'overThresh' => 0 },
                     'L1PBb_5end'     => { 'overThresh' => 0 },
                     'L1P4a_5end'     => { 'overThresh' => 0 },
                     'L1P4e_5end'     => { 'overThresh' => 0 },
                     'L1P1_5end'      => { 'overThresh' => 0 },
                     'L1P4b_5end'     => { 'overThresh' => 0 },
                     'L1PB3_3end'     => { 'overThresh' => 0 },
                     'L1P4d_5end'     => { 'overThresh' => 0 },
                     'L1PB1_3end'     => { 'overThresh' => 0 },
                     'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1ME5_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 33 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 33 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC'        => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 33 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 33 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 33 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1MD3_3end' => {
                      'L1MD'        => { 'overThresh' => 0 },
                      'L1M5'        => { 'overThresh' => 0 },
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 0 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1M4'        => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1M3' => {
                'L1M2a1_5end' => { 'overThresh' => 0 },
                'L1M2'        => { 'overThresh' => 0 },
                'L1M2b_5end'  => { 'overThresh' => 0 },
                'L1M3a_5end'  => { 'overThresh' => 0 },
                'L1MB2_3end'  => { 'overThresh' => 0 },
                'L1MB4_5end'  => { 'overThresh' => 0 },
                'L1M3e_5end'  => { 'overThresh' => 0 },
                'L1M2_5end'   => { 'overThresh' => 0 },
                'L1M3b_5end'  => { 'overThresh' => 0 },
                'L1M3d_5end'  => { 'overThresh' => 0 },
                'L1M4c_5end'  => { 'overThresh' => 0 },
                'L1MA8_3end'  => { 'overThresh' => 0 },
                'L1M2a_5end'  => { 'overThresh' => 0 },
                'L1MB4_3end'  => { 'overThresh' => 0 },
                'L1M4_5end'   => { 'overThresh' => 0 },
                'L1M4b_5end'  => { 'overThresh' => 0 },
                'L1M4'        => { 'overThresh' => 0 },
                'L1M3f_5end'  => { 'overThresh' => 0 },
                'L1M3c_5end'  => { 'overThresh' => 0 },
                'L1M3_orf2'   => { 'overThresh' => 0 },
                'L1M4_orf2'   => { 'overThresh' => 0 },
                'L1MB1_3end'  => { 'overThresh' => 0 },
                'L1MA10_3end' => { 'overThresh' => 0 },
                'L1M3de_5end' => { 'overThresh' => 0 },
                'L1M'         => { 'overThresh' => 0 },
                'L1M2_orf2'   => { 'overThresh' => 0 },
                'L1MA9_3end'  => { 'overThresh' => 0 },
                'L1M2c_5end'  => { 'overThresh' => 0 },
                'L1MB3_3end'  => { 'overThresh' => 0 },
                'L1MB5_3end'  => { 'overThresh' => 0 }
    },
    'L1MB3_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 33 },
                      'L1M3a_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 0 },
                      'L1MB4_5end'  => { 'overThresh' => 0 },
                      'L1M3e_5end'  => { 'overThresh' => 0 },
                      'L1MA4A_3end' => { 'overThresh' => 33 },
                      'L1M3b_5end'  => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1M3d_5end'  => { 'overThresh' => 0 },
                      'L1MA4_3end'  => { 'overThresh' => 33 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 33 },
                      'L1MA8_3end'  => { 'overThresh' => 33 },
                      'L1MB4_3end'  => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 0 },
                      'L1MA5_3end'  => { 'overThresh' => 33 },
                      'L1M3f_5end'  => { 'overThresh' => 0 },
                      'L1M3c_5end'  => { 'overThresh' => 0 },
                      'L1M3_orf2'   => { 'overThresh' => 0 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1M3de_5end' => { 'overThresh' => 0 },
                      'L1MA9_3end'  => { 'overThresh' => 33 },
                      'L1M3'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 33 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 0 }
    },
    'L1Md_A_3end' => {
                       'L1Md_T_3end'  => { 'overThresh' => 33 },
                       'L1Md_A_5end'  => { 'overThresh' => 0 },
                       'L1Md_F_5end'  => { 'overThresh' => 33 },
                       'L1Md_Gf_5end' => { 'overThresh' => 33 },
                       'L1_Mus1_3end' => { 'overThresh' => 33 },
                       'L1_Mus3_3end' => { 'overThresh' => 33 },
                       'L1_Mm_orf2'   => { 'overThresh' => 0 },
                       'L1_Mus2_3end' => { 'overThresh' => 33 },
                       'L1_Mus4_3end' => { 'overThresh' => 33 },
                       'L1Md_F3_3end' => { 'overThresh' => 33 },
                       'L1Md_F2_3end' => { 'overThresh' => 33 }
    },
    'L1_Mus4_3end' => {
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1_Mus3_3end' => { 'overThresh' => 0 },
                        'L1_Mus1_3end' => { 'overThresh' => 0 },
                        'L1Md_Gf_5end' => { 'overThresh' => 33 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Mus2_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 },
                        'L1Md_F3_3end' => { 'overThresh' => 33 },
                        'L1Md_T_3end'  => { 'overThresh' => 33 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'L1Md_A_5end'  => { 'overThresh' => 33 },
                        'L1Md_F_5end'  => { 'overThresh' => 33 },
                        'L1_Mm_orf2'   => { 'overThresh' => 0 },
                        'L1Md_A_3end'  => { 'overThresh' => 33 },
                        'L1Md_F2_3end' => { 'overThresh' => 33 }
    },
    'L1PB2_3end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PB4_3end'     => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1P4b_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1PB1_3end'     => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1_Carn3_3end' => {
                         'L1_Carn2_5end' => { 'overThresh' => 0 },
                         'L1_Carn3_5end' => { 'overThresh' => 0 },
                         'L1_Carn2_orf2' => { 'overThresh' => 0 }
    },
    'CiL1.2'         => { 'CiL1' => { 'overThresh' => 0 } },
    'L1_Canis0_3end' => {
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 }
    },
    'HAL1_Opos1_3end' => { 'HAL1_Opos1_5end' => { 'overThresh' => 0 } },
    'L1M6_5end'       => {
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1M5'        => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1ME3_3end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1ME2z_3end' => { 'overThresh' => 0 },
                     'L1ME3A_3end' => { 'overThresh' => 0 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1ME2_3end'  => { 'overThresh' => 0 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1ME4a_3end' => { 'overThresh' => 0 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1ME3B_3end' => { 'overThresh' => 0 },
                     'L1M7_5end'   => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1ME5_3end'  => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1M5_orf2'   => { 'overThresh' => 0 },
                     'L1ME1_3end'  => { 'overThresh' => 0 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 }
    },
    'L1MEf_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 33 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 33 },
                      'L1MC4_3end'  => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 0 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 0 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 33 },
                      'L1ME4a_3end' => { 'overThresh' => 0 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 0 },
                      'L1MC4a_3end' => { 'overThresh' => 33 },
                      'L1ME1_3end'  => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1MD3_3end'  => { 'overThresh' => 33 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1PA13_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1PA3_3end' => {
                      'L1PA7_3end'     => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1P1'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 33 },
                      'L1PA12_5end'    => { 'overThresh' => 33 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PA8A_3end'    => { 'overThresh' => 0 },
                      'L1P2'           => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 33 },
                      'L1PA8_3end'     => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 33 },
                      'L1PA6_3end'     => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1PA2_3end'     => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PA4_3end'     => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA10_5end'    => { 'overThresh' => 33 },
                      'L1PA5_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 33 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'ATLINE1_11' => { 'ATLINE1_1' => { 'overThresh' => 0 } },
    'Lx3C_3end'  => {
                     'L1_Mur1_5end' => { 'overThresh' => 0 },
                     'L1_Mur2_orf2' => { 'overThresh' => 0 },
                     'L1_Mur2_5end' => { 'overThresh' => 0 },
                     'L1_Mur1_orf2' => { 'overThresh' => 0 }
    },
    'L1PA15-16_5end' => {
                          'L1P4c_5end'   => { 'overThresh' => 0 },
                          'L1PB2_3end'   => { 'overThresh' => 33 },
                          'L1P'          => { 'overThresh' => 0 },
                          'L1PBa_5end'   => { 'overThresh' => 0 },
                          'L1PA14_3end'  => { 'overThresh' => 0 },
                          'L1P2_5end'    => { 'overThresh' => 0 },
                          'L1PA8_3end'   => { 'overThresh' => 33 },
                          'L1PA13_3end'  => { 'overThresh' => 0 },
                          'L1Pt_5end'    => { 'overThresh' => 0 },
                          'L1PA6_3end'   => { 'overThresh' => 33 },
                          'L1P1_orf2'    => { 'overThresh' => 0 },
                          'L1PA3_3end'   => { 'overThresh' => 33 },
                          'L1PREC2_orf2' => { 'overThresh' => 0 },
                          'L1P3_orf2'    => { 'overThresh' => 0 },
                          'L1PA4_3end'   => { 'overThresh' => 33 },
                          'L1PA13_5end'  => { 'overThresh' => 0 },
                          'L1PA10_5end'  => { 'overThresh' => 0 },
                          'L1PA5_3end'   => { 'overThresh' => 33 },
                          'L1PBb_5end'   => { 'overThresh' => 0 },
                          'L1P4a_5end'   => { 'overThresh' => 0 },
                          'L1PA10_3end'  => { 'overThresh' => 0 },
                          'L1P4_orf2'    => { 'overThresh' => 0 },
                          'L1PREC2_5end' => { 'overThresh' => 0 },
                          'L1PA7_3end'   => { 'overThresh' => 33 },
                          'L1P3_5end'    => { 'overThresh' => 0 },
                          'L1PA14_5end'  => { 'overThresh' => 0 },
                          'L1PA12_5end'  => { 'overThresh' => 0 },
                          'L1PA12_3end'  => { 'overThresh' => 0 },
                          'L1PA17_5end'  => { 'overThresh' => 0 },
                          'L1PA16_3end'  => { 'overThresh' => 0 },
                          'L1PA8A_3end'  => { 'overThresh' => 33 },
                          'L1P3b_5end'   => { 'overThresh' => 0 },
                          'L1PA11_3end'  => { 'overThresh' => 0 },
                          'L1PA2_3end'   => { 'overThresh' => 33 },
                          'L1PA15_3end'  => { 'overThresh' => 0 },
                          'L1PB4_3end'   => { 'overThresh' => 33 },
                          'L1PB_orf2'    => { 'overThresh' => 0 },
                          'L1P4'         => { 'overThresh' => 0 },
                          'L1PBa1_5end'  => { 'overThresh' => 0 },
                          'L1P4e_5end'   => { 'overThresh' => 0 },
                          'L1P4b_5end'   => { 'overThresh' => 0 },
                          'L1P1_5end'    => { 'overThresh' => 0 },
                          'L1PB3_3end'   => { 'overThresh' => 33 },
                          'L1P4d_5end'   => { 'overThresh' => 0 },
                          'L1PB1_3end'   => { 'overThresh' => 33 },
                          'L1PA17_3end'  => { 'overThresh' => 0 }
    },
    'L1_Canis0_orf2' => {
                          'L1_Canis1_3end' => { 'overThresh' => 0 },
                          'L1_Canis5_5end' => { 'overThresh' => 0 },
                          'L1_Canis0_3end' => { 'overThresh' => 0 },
                          'L1_Canis4_5end' => { 'overThresh' => 0 },
                          'L1_Canis2_5end' => { 'overThresh' => 0 },
                          'L1_Canis1_orf2' => { 'overThresh' => 0 },
                          'L1_Canis2_orf2' => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis4_orf2' => { 'overThresh' => 0 },
                          'L1_Canis1_5end' => { 'overThresh' => 0 },
                          'L1_Canis4_3end' => { 'overThresh' => 0 }
    },
    'L1MC1_3end' => {
                      'L1MD'        => { 'overThresh' => 33 },
                      'L1MD2_5end'  => { 'overThresh' => 33 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 33 },
                      'L1MEg_5end'  => { 'overThresh' => 33 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 33 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 33 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 33 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 33 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 33 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 33 },
                      'L1MEd_5end'  => { 'overThresh' => 33 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MEb_5end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1MA5_3end' => {
                      'L1MA6_3end'  => { 'overThresh' => 0 },
                      'L1M2a1_5end' => { 'overThresh' => 0 },
                      'L1M1_orf2'   => { 'overThresh' => 0 },
                      'L1M2'        => { 'overThresh' => 0 },
                      'L1M2b_5end'  => { 'overThresh' => 0 },
                      'L1MB2_3end'  => { 'overThresh' => 33 },
                      'L1MB4_5end'  => { 'overThresh' => 33 },
                      'L1MA4A_3end' => { 'overThresh' => 0 },
                      'L1M2_5end'   => { 'overThresh' => 0 },
                      'L1MA2_3end'  => { 'overThresh' => 33 },
                      'L1MA4_3end'  => { 'overThresh' => 0 },
                      'L1MB8_3end'  => { 'overThresh' => 33 },
                      'L1MA3_3end'  => { 'overThresh' => 33 },
                      'L1MA5A_3end' => { 'overThresh' => 0 },
                      'L1MA8_3end'  => { 'overThresh' => 0 },
                      'L1M2a_5end'  => { 'overThresh' => 0 },
                      'L1M1_5end'   => { 'overThresh' => 0 },
                      'L1MB4_3end'  => { 'overThresh' => 33 },
                      'L1M1'        => { 'overThresh' => 0 },
                      'L1MB1_3end'  => { 'overThresh' => 33 },
                      'L1MA10_3end' => { 'overThresh' => 33 },
                      'L1MA9_3end'  => { 'overThresh' => 0 },
                      'L1M2_orf2'   => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MB3_3end'  => { 'overThresh' => 33 },
                      'L1M2c_5end'  => { 'overThresh' => 0 },
                      'L1MA7_3end'  => { 'overThresh' => 0 },
                      'L1MB7_3end'  => { 'overThresh' => 33 },
                      'L1MA1_3end'  => { 'overThresh' => 33 },
                      'L1MB5_3end'  => { 'overThresh' => 33 }
    },
    'Lx6_3end' => {
                    'L1_Mur2_orf2' => { 'overThresh' => 0 },
                    'L1_Mur2_5end' => { 'overThresh' => 0 },
                    'L1_Mur3_5end' => { 'overThresh' => 0 },
                    'L1_Mur3_orf2' => { 'overThresh' => 0 }
    },
    'L1_RS2_3end' => {
                       'L1_RS1_orf2' => { 'overThresh' => 0 },
                       'L1_RS1_5end' => { 'overThresh' => 0 }
    },
    'L1M2_orf2' => {
                     'L1M2a1_5end' => { 'overThresh' => 0 },
                     'L1MA6_3end'  => { 'overThresh' => 0 },
                     'L1M1_orf2'   => { 'overThresh' => 0 },
                     'L1M2'        => { 'overThresh' => 0 },
                     'L1M2b_5end'  => { 'overThresh' => 0 },
                     'L1M3a_5end'  => { 'overThresh' => 0 },
                     'L1M3e_5end'  => { 'overThresh' => 0 },
                     'L1MA4A_3end' => { 'overThresh' => 0 },
                     'L1M2_5end'   => { 'overThresh' => 0 },
                     'L1M3b_5end'  => { 'overThresh' => 0 },
                     'L1M3d_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MA4_3end'  => { 'overThresh' => 0 },
                     'L1MA5A_3end' => { 'overThresh' => 0 },
                     'L1M1_5end'   => { 'overThresh' => 0 },
                     'L1M2a_5end'  => { 'overThresh' => 0 },
                     'L1MA8_3end'  => { 'overThresh' => 0 },
                     'L1M1'        => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1MA5_3end'  => { 'overThresh' => 0 },
                     'L1M3f_5end'  => { 'overThresh' => 0 },
                     'L1M3_orf2'   => { 'overThresh' => 0 },
                     'L1M3c_5end'  => { 'overThresh' => 0 },
                     'L1M3de_5end' => { 'overThresh' => 0 },
                     'L1MA9_3end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1M3'        => { 'overThresh' => 0 },
                     'L1M2c_5end'  => { 'overThresh' => 0 },
                     'L1MA7_3end'  => { 'overThresh' => 0 }
    },
    'L1MCc_5end' => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MCb_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Mars1_5end' => { 'L1_Mars1_orf2' => { 'overThresh' => 0 } },
    'L1MCb_5end'    => {
                      'L1MD2_5end'  => { 'overThresh' => 0 },
                      'L1ME2z_3end' => { 'overThresh' => 33 },
                      'L1MC2_3end'  => { 'overThresh' => 0 },
                      'L1MC5_3end'  => { 'overThresh' => 0 },
                      'L1M6_5end'   => { 'overThresh' => 0 },
                      'L1MD1_3end'  => { 'overThresh' => 33 },
                      'L1MEf_5end'  => { 'overThresh' => 0 },
                      'L1MEg_5end'  => { 'overThresh' => 0 },
                      'L1ME3B_3end' => { 'overThresh' => 33 },
                      'L1MCa_5end'  => { 'overThresh' => 0 },
                      'L1M7_5end'   => { 'overThresh' => 0 },
                      'L1MC4_3endX' => { 'overThresh' => 0 },
                      'L1MD_orf2'   => { 'overThresh' => 0 },
                      'L1M4_5end'   => { 'overThresh' => 0 },
                      'L1M5_orf2'   => { 'overThresh' => 0 },
                      'L1M4b_5end'  => { 'overThresh' => 0 },
                      'L1MC1_3end'  => { 'overThresh' => 0 },
                      'L1MC4_5end'  => { 'overThresh' => 0 },
                      'L1MC4_3end'  => { 'overThresh' => 0 },
                      'L1MC'        => { 'overThresh' => 0 },
                      'L1M'         => { 'overThresh' => 0 },
                      'L1MCc_5end'  => { 'overThresh' => 0 },
                      'L1MEa_5end'  => { 'overThresh' => 0 },
                      'L1MC_orf2'   => { 'overThresh' => 0 },
                      'L1MEg2_5end' => { 'overThresh' => 0 },
                      'L1ME3_3end'  => { 'overThresh' => 33 },
                      'L1MDa_5end'  => { 'overThresh' => 0 },
                      'L1ME3A_3end' => { 'overThresh' => 33 },
                      'L1MEe_5end'  => { 'overThresh' => 0 },
                      'L1ME2_3end'  => { 'overThresh' => 33 },
                      'L1MD2_3end'  => { 'overThresh' => 33 },
                      'L1MEg1_5end' => { 'overThresh' => 0 },
                      'L1MC3_3end'  => { 'overThresh' => 0 },
                      'L1ME4a_3end' => { 'overThresh' => 33 },
                      'L1MEc_5end'  => { 'overThresh' => 0 },
                      'L1MEd_5end'  => { 'overThresh' => 0 },
                      'L1M4c_5end'  => { 'overThresh' => 0 },
                      'L1MEb_5end'  => { 'overThresh' => 0 },
                      'L1ME5_3end'  => { 'overThresh' => 33 },
                      'L1MC4a_3end' => { 'overThresh' => 0 },
                      'L1M4_orf2'   => { 'overThresh' => 0 },
                      'L1ME1_3end'  => { 'overThresh' => 33 },
                      'L1MD3_3end'  => { 'overThresh' => 0 },
                      'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1PA14_5end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1Pt_5end'      => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1P1_orf2'      => { 'overThresh' => 0 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PREC2_orf2'   => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PBb_5end'     => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_5end'   => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB4_3end'     => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P1_5end'      => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 33 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PB1_3end'     => { 'overThresh' => 33 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1MC_orf2' => {
                     'L1MD2_5end'  => { 'overThresh' => 0 },
                     'L1ME2z_3end' => { 'overThresh' => 33 },
                     'L1MC2_3end'  => { 'overThresh' => 0 },
                     'L1MC5_3end'  => { 'overThresh' => 0 },
                     'L1MD1_3end'  => { 'overThresh' => 33 },
                     'L1MEf_5end'  => { 'overThresh' => 0 },
                     'L1MEg_5end'  => { 'overThresh' => 0 },
                     'L1ME3B_3end' => { 'overThresh' => 33 },
                     'L1MCa_5end'  => { 'overThresh' => 0 },
                     'L1MC4_3endX' => { 'overThresh' => 0 },
                     'L1M4_5end'   => { 'overThresh' => 0 },
                     'L1M4b_5end'  => { 'overThresh' => 0 },
                     'L1MC1_3end'  => { 'overThresh' => 0 },
                     'L1MC'        => { 'overThresh' => 0 },
                     'L1MC4_3end'  => { 'overThresh' => 0 },
                     'L1MC4_5end'  => { 'overThresh' => 0 },
                     'L1M'         => { 'overThresh' => 0 },
                     'L1MCc_5end'  => { 'overThresh' => 0 },
                     'L1MEa_5end'  => { 'overThresh' => 0 },
                     'L1MCb_5end'  => { 'overThresh' => 0 },
                     'L1MEg2_5end' => { 'overThresh' => 0 },
                     'L1ME3_3end'  => { 'overThresh' => 33 },
                     'L1MDa_5end'  => { 'overThresh' => 0 },
                     'L1ME3A_3end' => { 'overThresh' => 33 },
                     'L1MEe_5end'  => { 'overThresh' => 0 },
                     'L1ME2_3end'  => { 'overThresh' => 33 },
                     'L1MD2_3end'  => { 'overThresh' => 33 },
                     'L1MC3_3end'  => { 'overThresh' => 0 },
                     'L1MEg1_5end' => { 'overThresh' => 0 },
                     'L1ME4a_3end' => { 'overThresh' => 33 },
                     'L1MEc_5end'  => { 'overThresh' => 0 },
                     'L1M4c_5end'  => { 'overThresh' => 0 },
                     'L1MEd_5end'  => { 'overThresh' => 0 },
                     'L1MEb_5end'  => { 'overThresh' => 0 },
                     'L1ME5_3end'  => { 'overThresh' => 33 },
                     'L1MC4a_3end' => { 'overThresh' => 0 },
                     'L1ME1_3end'  => { 'overThresh' => 33 },
                     'L1MD3_3end'  => { 'overThresh' => 0 },
                     'L1MDb_5end'  => { 'overThresh' => 0 }
    },
    'L1_Canis5_5end' => {
                          'L1_Carn2_3end'  => { 'overThresh' => 0 },
                          'L1_Canis4_5end' => { 'overThresh' => 0 },
                          'L1_Carn2_orf2'  => { 'overThresh' => 0 },
                          'L1_Canis0_orf2' => { 'overThresh' => 0 },
                          'L1_Carn2_5end'  => { 'overThresh' => 0 },
                          'L1_Carn1_5end'  => { 'overThresh' => 0 },
                          'L1_Canis0_5end' => { 'overThresh' => 0 },
                          'L1_Canis4_orf2' => { 'overThresh' => 0 },
                          'L1_Canis4_3end' => { 'overThresh' => 0 }
    },
    'L1PA17_5end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1PB2_3end'     => { 'overThresh' => 33 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PBa_5end'     => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1P2_5end'      => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 33 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1Pt_5end'      => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1P1_orf2'      => { 'overThresh' => 0 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1PREC2_orf2'   => { 'overThresh' => 0 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PBb_5end'     => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PREC2_5end'   => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 33 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 33 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA11_3end'    => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1PB4_3end'     => { 'overThresh' => 33 },
                       'L1PB_orf2'      => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1PBa1_5end'    => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1PB3_3end'     => { 'overThresh' => 33 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P1_5end'      => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PB1_3end'     => { 'overThresh' => 33 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1_Mdo4_5end' => {
                        'L1_Mdo5_3end' => { 'overThresh' => 0 },
                        'L1_Mdo4_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo5_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo4_3end' => { 'overThresh' => 0 },
                        'L1_Mdo5_5end' => { 'overThresh' => 0 }
    },
    'Lx8_3end' => {
                    'L1_Rod_orf2'  => { 'overThresh' => 0 },
                    'L1_Rod_5end'  => { 'overThresh' => 0 },
                    'L1_Mur3_5end' => { 'overThresh' => 0 },
                    'L1_Mur3_orf2' => { 'overThresh' => 0 }
    },
    'L1PA11_3end' => {
                       'L1P4c_5end'     => { 'overThresh' => 0 },
                       'L1P'            => { 'overThresh' => 0 },
                       'L1PA14_3end'    => { 'overThresh' => 0 },
                       'L1PA8_3end'     => { 'overThresh' => 0 },
                       'L1PA13_3end'    => { 'overThresh' => 0 },
                       'L1PA6_3end'     => { 'overThresh' => 33 },
                       'L1PA3_3end'     => { 'overThresh' => 33 },
                       'L1P3_orf2'      => { 'overThresh' => 0 },
                       'L1PA4_3end'     => { 'overThresh' => 33 },
                       'L1PA13_5end'    => { 'overThresh' => 0 },
                       'L1PA5_3end'     => { 'overThresh' => 33 },
                       'L1PA10_5end'    => { 'overThresh' => 0 },
                       'L1PA15-16_5end' => { 'overThresh' => 0 },
                       'L1P4a_5end'     => { 'overThresh' => 0 },
                       'L1PA10_3end'    => { 'overThresh' => 0 },
                       'L1P4_orf2'      => { 'overThresh' => 0 },
                       'L1PA7_3end'     => { 'overThresh' => 0 },
                       'L1P3_5end'      => { 'overThresh' => 0 },
                       'L1PA14_5end'    => { 'overThresh' => 0 },
                       'L1PA12_3end'    => { 'overThresh' => 0 },
                       'L1PA12_5end'    => { 'overThresh' => 0 },
                       'L1P3'           => { 'overThresh' => 0 },
                       'L1PA17_5end'    => { 'overThresh' => 0 },
                       'L1PA16_3end'    => { 'overThresh' => 0 },
                       'L1PA8A_3end'    => { 'overThresh' => 0 },
                       'L1P3b_5end'     => { 'overThresh' => 0 },
                       'L1PA2_3end'     => { 'overThresh' => 33 },
                       'L1PA15_3end'    => { 'overThresh' => 0 },
                       'L1P4'           => { 'overThresh' => 0 },
                       'L1P4e_5end'     => { 'overThresh' => 0 },
                       'L1P4b_5end'     => { 'overThresh' => 0 },
                       'L1P4d_5end'     => { 'overThresh' => 0 },
                       'L1PA17_3end'    => { 'overThresh' => 0 }
    },
    'L1_Mdo2_orf2' => {
                        'L1_Mdo1_3end' => { 'overThresh' => 0 },
                        'L1_Mdo1_orf2' => { 'overThresh' => 0 },
                        'L1_Mdo2_5end' => { 'overThresh' => 0 },
                        'L1_Mdo2_3end' => { 'overThresh' => 0 },
                        'L1_Mdo1_5end' => { 'overThresh' => 0 }
    },
    'L1_Rat2_3end' => {
                        'L1_Rn_5end'   => { 'overThresh' => 33 },
                        'L1_Rat1_3end' => { 'overThresh' => 0 },
                        'Lx_3end'      => { 'overThresh' => 33 },
                        'L1_Rn2_3end'  => { 'overThresh' => 33 },
                        'L1_Rat4_3end' => { 'overThresh' => 0 },
                        'Lx2A_3end'    => { 'overThresh' => 33 },
                        'Lx2_3end'     => { 'overThresh' => 33 },
                        'L1_Rn_3end'   => { 'overThresh' => 33 },
                        'Lx2B_3end'    => { 'overThresh' => 33 },
                        'L1_Rn_orf2'   => { 'overThresh' => 33 },
                        'L1_Rat3_3end' => { 'overThresh' => 0 },
                        'Lx2A1_3end'   => { 'overThresh' => 33 }
    },
    'L1PB4_3end' => {
                      'L1PA15_3end'    => { 'overThresh' => 33 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 33 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 33 },
                      'L1PA14_3end'    => { 'overThresh' => 33 },
                      'L1PA15-16_5end' => { 'overThresh' => 33 },
                      'L1PA16_3end'    => { 'overThresh' => 33 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1PB1_3end'     => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 33 }
    },
    'L1_Carn3_5end' => {
                         'L1_Carn2_5end' => { 'overThresh' => 0 },
                         'L1_Carn3_3end' => { 'overThresh' => 0 },
                         'L1_Carn2_3end' => { 'overThresh' => 0 },
                         'L1_Carn2_orf2' => { 'overThresh' => 0 }
    },
    'L1MC4a_3end' => {
                       'L1MD'        => { 'overThresh' => 33 },
                       'L1M5'        => { 'overThresh' => 0 },
                       'L1MD2_5end'  => { 'overThresh' => 33 },
                       'L1ME2z_3end' => { 'overThresh' => 33 },
                       'L1MC2_3end'  => { 'overThresh' => 0 },
                       'L1MC5_3end'  => { 'overThresh' => 0 },
                       'L1MD1_3end'  => { 'overThresh' => 33 },
                       'L1MEf_5end'  => { 'overThresh' => 33 },
                       'L1MEg_5end'  => { 'overThresh' => 33 },
                       'L1ME3B_3end' => { 'overThresh' => 33 },
                       'L1MCa_5end'  => { 'overThresh' => 0 },
                       'L1MC4_3endX' => { 'overThresh' => 0 },
                       'L1M4_5end'   => { 'overThresh' => 0 },
                       'L1MD_orf2'   => { 'overThresh' => 33 },
                       'L1M5_orf2'   => { 'overThresh' => 0 },
                       'L1M4b_5end'  => { 'overThresh' => 0 },
                       'L1MC1_3end'  => { 'overThresh' => 0 },
                       'L1M4'        => { 'overThresh' => 0 },
                       'L1MC'        => { 'overThresh' => 0 },
                       'L1MC4_3end'  => { 'overThresh' => 0 },
                       'L1MC4_5end'  => { 'overThresh' => 0 },
                       'L1M'         => { 'overThresh' => 0 },
                       'L1MCc_5end'  => { 'overThresh' => 0 },
                       'L1MEa_5end'  => { 'overThresh' => 33 },
                       'L1MCb_5end'  => { 'overThresh' => 0 },
                       'L1MEg2_5end' => { 'overThresh' => 33 },
                       'L1MC_orf2'   => { 'overThresh' => 0 },
                       'L1ME3_3end'  => { 'overThresh' => 33 },
                       'L1MDa_5end'  => { 'overThresh' => 33 },
                       'L1ME3A_3end' => { 'overThresh' => 33 },
                       'L1MEe_5end'  => { 'overThresh' => 33 },
                       'L1ME2_3end'  => { 'overThresh' => 33 },
                       'L1MD2_3end'  => { 'overThresh' => 33 },
                       'L1MC3_3end'  => { 'overThresh' => 0 },
                       'L1MEg1_5end' => { 'overThresh' => 33 },
                       'L1ME4a_3end' => { 'overThresh' => 33 },
                       'L1MEc_5end'  => { 'overThresh' => 33 },
                       'L1MEd_5end'  => { 'overThresh' => 33 },
                       'L1M4c_5end'  => { 'overThresh' => 0 },
                       'L1MEb_5end'  => { 'overThresh' => 33 },
                       'L1ME5_3end'  => { 'overThresh' => 33 },
                       'L1ME1_3end'  => { 'overThresh' => 33 },
                       'L1M4_orf2'   => { 'overThresh' => 0 },
                       'L1MD3_3end'  => { 'overThresh' => 0 },
                       'L1MDb_5end'  => { 'overThresh' => 33 }
    },
    'L1P4b_5end' => {
                      'L1P4c_5end'     => { 'overThresh' => 0 },
                      'L1PB2_3end'     => { 'overThresh' => 0 },
                      'L1P'            => { 'overThresh' => 0 },
                      'L1PBa_5end'     => { 'overThresh' => 0 },
                      'L1PA14_3end'    => { 'overThresh' => 0 },
                      'L1P2_5end'      => { 'overThresh' => 0 },
                      'L1PA13_3end'    => { 'overThresh' => 0 },
                      'L1P1_orf2'      => { 'overThresh' => 0 },
                      'L1Pt_5end'      => { 'overThresh' => 0 },
                      'L1PREC2_orf2'   => { 'overThresh' => 0 },
                      'L1P3_orf2'      => { 'overThresh' => 0 },
                      'L1PA13_5end'    => { 'overThresh' => 0 },
                      'L1PA15-16_5end' => { 'overThresh' => 0 },
                      'L1PA10_5end'    => { 'overThresh' => 0 },
                      'L1PBb_5end'     => { 'overThresh' => 0 },
                      'L1P4a_5end'     => { 'overThresh' => 0 },
                      'L1PA10_3end'    => { 'overThresh' => 0 },
                      'L1P4_orf2'      => { 'overThresh' => 0 },
                      'L1PREC2_5end'   => { 'overThresh' => 0 },
                      'L1P3_5end'      => { 'overThresh' => 0 },
                      'L1PA14_5end'    => { 'overThresh' => 0 },
                      'L1P3'           => { 'overThresh' => 0 },
                      'L1PA12_3end'    => { 'overThresh' => 0 },
                      'L1PA12_5end'    => { 'overThresh' => 0 },
                      'L1PA17_5end'    => { 'overThresh' => 0 },
                      'L1PA16_3end'    => { 'overThresh' => 0 },
                      'L1P3b_5end'     => { 'overThresh' => 0 },
                      'L1PA11_3end'    => { 'overThresh' => 0 },
                      'L1P5'           => { 'overThresh' => 0 },
                      'L1PA15_3end'    => { 'overThresh' => 0 },
                      'L1PB_orf2'      => { 'overThresh' => 0 },
                      'L1P4'           => { 'overThresh' => 0 },
                      'L1PBa1_5end'    => { 'overThresh' => 0 },
                      'L1P4e_5end'     => { 'overThresh' => 0 },
                      'L1PB3_3end'     => { 'overThresh' => 0 },
                      'L1P1_5end'      => { 'overThresh' => 0 },
                      'L1P4d_5end'     => { 'overThresh' => 0 },
                      'L1PA17_3end'    => { 'overThresh' => 0 }
        }

      );
}
